//+----------------------------------------------------------------------------+
//|                                                                            |
//|  Advanced #5  H1 TL Breakout                                               |
//|                                                                            |
//|  http://www.forex-strategies-revealed.com/advanced/trendlines-breakout.htm |
//|                                                                            |
//+----------------------------------------------------------------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#define RESISTANCE 1
#define SUPPORT 2

#include <stdlib.mqh>

extern int MagicNumber = 0;
extern bool SignalMail = false;
extern bool EachTickMode = false;
extern double Lots = 0.1;
extern int Slippage = 3;
extern bool UseStopLoss = false;
extern int StopLoss = 20;
extern bool UseTakeProfit = false;
extern int TakeProfit = 30;
extern bool UseTrailingStop = true;
extern int TrailingStop = 30;

// ------------------------------------------------------------

extern bool UseSLnotExit = true;
extern int SLExitPips=3;

extern int BELockAtPips = 30;
int BELockAdd =1;

// --------------------- ---------------- ---------------------

extern color H1_R=RoyalBlue;
extern color H1_S=FireBrick;
extern color H1_R_=RoyalBlue;
extern color H1_S_=FireBrick;
color H4_R=RoyalBlue;
color H4_S=FireBrick;
color D1_R=RoyalBlue;
color D1_S=FireBrick;
color W1_R=RoyalBlue;
color W1_S=FireBrick;

extern bool ChangeBrokenTLColor = false;
extern color BrokenUPTL=LightBlue;
extern color BrokenDNTL=Orange;

extern color range_start = Green;
extern color range_start_ext = Yellow;
extern color range_end = Red;

// --------------------- ---------------- ---------------------

extern bool use_range = true;

extern int strategy_version = 2;     // 1: original, 2: +3 bars w EMA200

extern string RangeFirstBarTime = "07:00";    // range first bar time
extern int range_length = 5;                  // range length in H1 bars count
extern string RangeFirstBarTime_v2 = "04:00"; // range first bar time

extern bool UseTimeFilter = true;
extern string FirstTradingHour="08:00";
extern string FirstTradingHour_v2="05:00";
extern string LastTradingHour="22:00";

extern int TLBreakoutMinPips = 6;
extern int TLBreakoutMaxPips = 15;
extern int StopAddPips = 6;
extern int TPSubsPips = 3;
extern int MinPSRDist = 5;
extern int MaxPSRDist = 15;

extern bool DisplayInsideBars = true;
extern bool DisplaySidewaysPattern = true;
extern bool DisplayHTLs = true;

extern bool PivotBrokerTime = true;
extern string PivotStartingHour="00:00";
extern bool UseMidPivots=false;
extern bool UseWeeklyPivots=true;
extern bool UseMonthlyPivots=true;

extern bool CheckHistoryLoad=true;
extern int CheckHistoryOnLoad = 11000;
extern int CheckLoadedBars=1000;

extern bool OnlyOneTradeADay = false;   // Trade only first breakout in one direction
extern bool TradeBrokenTLs = false;     // Do not Trade already Broken Trendlines
extern int OOTD_period = PERIOD_M5;     // History check periods

extern bool loggingenabled = true;
extern bool loggingsnapshot = true;

#define RESISTANCE 1
#define SUPPORT 2

datetime currentbar;
datetime currentbar2[10];
datetime currentbar3[10];

double H1R_E, H1R_S, H1S_E, H1S_S;
double TLBU, TLBD;

extern bool TradeType1 = true;     // 1: Exit1stPSR
extern bool TradeType2 = true;     // 2: ExitAfter3HRS
extern bool TradeType3 = true;     // 3: Trail previous bar high/low
extern bool TradeType4 = false;    // 4: Pending Orders (buy/sell STOP)

double PPs[14][4];
string PPn[14] = {"", "S3", "S2.5", "S2", "S1.5", "S1", "S0.5", "PP", "R0.5", "R1", "R1.5", "R2", "R2.5", "R3" };
int PPcol[14] = {0, Red, Tomato, Red, Tomato, Red, Tomato, Magenta, YellowGreen, LimeGreen, YellowGreen, LimeGreen, YellowGreen, LimeGreen };
string PPTFn[5] = {"", "Daily ", "Weekly ", "Monthly " };

// --------------------- ---------------- ---------------------
extern bool UseSetup1 = false;  // M5 swing high/low break
extern bool UseSetup2 = false;  // 2x M5 bar close above/below TL
extern bool UseSetup3 = true;   // simple price x pips above/below TL
// --------------------- ---------------- ---------------------
// TRADING PARAMETERS:

extern int MinSL = 10;
extern int MaxSLPerTrade = 100;
extern bool NoTradeOverMaxSL = false;

extern int MaxTotalOpenSL = 1000;

extern bool fixedspread = true;
extern int maxspread = 8;

extern int TPShift = 1;      // Trade Type 1

extern bool UseFixedTarget = false;

extern int MagicNRMin = 170000;
extern int MagicNRMax = 180000;

// --------------------- ---------------- ---------------------

// --- FILTERING ---

// TF Check Values: 0: NONE, 1: H1, 2: H4, 3: H1&H4, 4: D1, 5: H1&D1, 6: H4&D1, 7: H1&H4&D1

extern int MTF2_MA_Type = MODE_EMA;
extern int MTF2_MA_Period_Fast = 9;
extern int MTF2_MA_Period_Slow = 18;
extern int MTF3_MA_Type = MODE_EMA;
extern int MTF3_MA_Period = 200;
extern int RSITrendFilterPeriod = 14;
extern int CCITrendFilterPeriod = 14;

extern bool TradeOnlyPivotDir=false;      // above PP only BUY / below PP only SELL 

string HTFCheckS[10] = { "", "H1,H4,D1","","","","","","","","","" };
int HTFCheck[10] = { 0,0,0,0,0,0,0,0,0,0,0 };
// int HTFCheck[10] = { 0,7,7,7,7,7,7,7,0,0,0 };
// HTFCheck Values: 0: NONE, 1: H1, 2: H4, 3: H1&H4, 4: D1, 5: H1&D1, 6: H4&D1, 7: H1&H4&D1

//bool MTFCheck[10] = { false,true,true,true,true,true,false,false,false,false };
bool MTFCheck[10] = { false,false,false,false,false,false,false,false,false,false };
//                    0     M1    M5    M15   M30   H1    H4    D1    W1    MN1
bool MTFCheck2[10]= { false,false,false,false,false,true, true, true, false,false };
string MTFn[10];
string MTFi[10];
string MTFii[10];
int MTFs[10];
int MTFsc[10][4];
int MTFc[10][10][3];

// --------------------- ---------------- ---------------------

   string mamodes[5] = {"SMA", "EMA", "SMMA", "LWMA" };

   string tpairs[34] = {"",
   "EURUSD", "GBPUSD", "USDJPY", "USDCHF", "USDCAD", "AUDUSD", "NZDUSD", "GBPCHF", "GBPJPY",
   "EURAUD", "EURCHF", "EURJPY", "EURGBP", "EURCAD", "CHFJPY", "AUDNZD", "AUDJPY", "CADJPY",
   "EURNZD", "GBPNZD", "CADCHF", "AUDCAD", "GBPAUD", "GBPCAD", "AUDCHF", "NZDCAD", "NZDCHF", "NZDJPY",
   "EURSEK", "EURNOK", "USDSEK", "USDNOK"
   };

/* ALPARI +26 pairs
"AUDSGD","CADSGD","CHFSGD","EURDKK","EURHKD",
"EURPLN","EURSGD","EURTRY","GBPNOK","GBPSEK",
"GBPSGD","HKDJPY","NOKJPY","NOKSEK","NZDSGD",
"SEKJPY","SGDJPY","SGDJPY","USDDKK","USDDKK",
"USDHKD","USDHKD","USDPLN","USDSGD","USDSGD",
"USDTRY"
*/

   double avgspreads[34] = {0,
      1.0, 2.0, 1.0, 2.0, 2.0, 1.5, 2.5, 5.5, 3.5,
      3.0, 2.5, 2.0, 1.5, 4.0, 3.0, 5.5, 2.5, 3.0,
      7.0, 10.0, 5.0, 4.0, 5.5, 6.0, 4.0, 5.5, 5.5, 3.5,
      26.5, 20.0, 34.5, 27.0 };

   int FixedTPTargets[34] = {0,
      30, 30, 30, 30, 30, 30, 30, 30, 30,
      30, 30, 30, 30, 30, 30, 30, 30, 30,
      30, 30, 30, 30, 30, 30, 30, 30, 30, 30,
      30, 30, 30, 30 };

int TFs[10]={ 0, 1, 5, 15, 30, 60, 240, 1440, 10080, 43200 };
string TFns[10]={ "", "M1", "M5", "M15", "M30", "H1", "H4", "D1", "W1", "MN" };
int tpo[8];
datetime NextCheck[10];

int TPTarget, avgspread;

int h1,h2,l1,l2;
double hh1,hh2,ll1,ll2;

double SR6S[10], SR6R[10], SR7S[10], SR7R[10];
double v1[200];
double v2[200];

bool tmi1;
int dgt=1; int dgt2=0;
double sll=0;

double buytgt=0;
double buysl=0;
double selltgt=0;
double sellsl=0;

bool NoBuyToday=false;
bool NoSellToday=false;
int mmnr1, mmnr2, mmnr3, mmnr4;

double ipr;
double TLUM=0, TLLM=0;

// --- price range detecting
double PRL, PRH;

double cpr[10][5]; // inside bar
double cps[10][5]; // sideways pattern

string comm2="";
string comm3="";
string comm_bu="";
string comm_bd="";
string comm_sw="";
string comm_tech_history="";
string comm_tech_tls="";
string elog="";
string b4r="";
string tk1, tk2;
int OOTDbar=0, tickets_t1=0, tickets_t2=0;

int _h1[10], _h2[10], _l1[10], _l2[10];
double _hh1[10], _hh2[10], _ll1[10], _ll2[10];
double _H1R_E[10], _H1R_S[10], _H1S_E[10], _H1S_S[10];
double _TLBU[10], _TLBD[10];

string TLcomm[10];
string RRcomm[10];

double trtr[100][15];
string trts[100][15];

int initlog=2;

double rate_array[][6];

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   objdel();

   MTFn[1]="PPMA";
   MTFn[2]=mamodes[MTF2_MA_Type]+"("+MTF2_MA_Period_Fast+","+MTF2_MA_Period_Slow+")";
   MTFn[3]=mamodes[MTF3_MA_Type]+"("+MTF3_MA_Period+")";
   MTFn[4]="MACD hist.";
   MTFn[5]="MACD cross";
   MTFn[6]="RSI("+RSITrendFilterPeriod+")";
   MTFn[7]="CCI("+CCITrendFilterPeriod+")";

   int apnr=getpairnr(StringSubstr(Symbol(),0,6));
   if (apnr>0)
   {
      avgspread=avgspreads[apnr];
      TPTarget=FixedTPTargets[apnr];
   }

   mmnr1=makemagicnr(apnr, 1);
   mmnr2=makemagicnr(apnr, 2);
   mmnr3=makemagicnr(apnr, 3);
   mmnr4=makemagicnr(apnr, 4);

   if (OnlyOneTradeADay)
   {
      checkorderhist(Symbol());
      Print(Symbol(), " Order History Check : BUY: ", NoBuyToday);
      Print(Symbol(), " Order History Check : SELL: ", NoSellToday);
   }

   currentbar=0;
   
   // --- Multiply variables for 3,5 digit brokers ---
   if (Digits==3 || Digits==5)
   {
      dgt=10;
      dgt2=1;
      StopLoss*=10;
      TakeProfit*=10;
      TrailingStop*=10;
      SLExitPips*=10;
      BELockAtPips*=10;
      TLBreakoutMinPips*=10;
      TLBreakoutMaxPips*=10;
      StopAddPips*=10;
      TPSubsPips*=10;
      MinPSRDist*=10;
      MaxPSRDist*=10;
      MinSL*=10;
      MaxSLPerTrade*=10;
      MaxTotalOpenSL*=10;
      maxspread*=10;
      //NextTPPips*=10;
      avgspread*=10;
      TPTarget*=10;
      BELockAdd*=10;
   }
   // ------------------------------------------------

   Print("--- last bar time check -----------------");   
   datetime hck[10];
   ArrayInitialize(hck,-1);

   datetime dt1=TimeCurrent();
   string tk0=TimeToStr(dt1, TIME_DATE|TIME_MINUTES);  // MM.DD hh:mm  // ("01.01 00:00")
   Print(Symbol(),"/",Period()," server time: ",tk0, " timestamp: ", dt1);
   bool mindoke=false;
   while (!mindoke && CheckHistoryLoad)
   {
      mindoke=true;
      for (int x=1;x<10;x++)
      {
         if ((hck[x]==-1) && (CheckHistoryOnLoad>=TFs[x]))
         {
            string ap=Symbol();
            int tfc=TFs[x];
            RefreshRates();
            hck[x]=iTime(ap,tfc,0);
            datetime tt=TimeCurrent();
            tk0=TimeToStr(hck[x],TIME_DATE|TIME_MINUTES);  // MM.DD hh:mm  // ("01.01 00:00") 
            tk1=TimeToStr(tt,TIME_DATE|TIME_MINUTES);  // MM.DD hh:mm  // ("01.01 00:00") 
            if ((tt-hck[x])>(tfc*60))
            {
               Print("Hist LOADING: ",ap,"/",tfc,"/",x,"/",tk0, " LBT: ", hck[x], " tcurr: ", tt, " (",tk1,") diff: ", tt-hck[x], " tfc: ", tfc*60);
               mindoke=false; hck[x]=-1;
               Sleep(100); // 1000: wait for 1 sec
            }
            else
            {
               //Print("Hist OK: ",ap,"/",tfc,"/",x,"/",tk0, " LBT: ", hck[x], " tcurr: ", tt, " (",tk1," diff: ", tt-hck[x], " tfc: ", tfc*60);
            }
         }
      }
   }

   if (CheckLoadedBars>0)
   {
      ap=Symbol();
      if (iBars(Symbol(),PERIOD_H1)<CheckLoadedBars)
      {
         comm_tech_history="Not enough H1 history loaded: "+iBars(Symbol(),PERIOD_H1)+" needed: "+CheckLoadedBars+"\n";
         Print(ap, " Not enough H1 history loaded: ", iBars(Symbol(),PERIOD_H1), " needed: ", CheckLoadedBars);
         CheckLoadedBars=iBars(Symbol(),PERIOD_H1)-2;
      }
      for (int i=0;i<CheckLoadedBars;i++)
      {
         tfc=60; // TFs[x];
         datetime t1=iTime(ap,tfc,i);
         datetime t2=iTime(ap,tfc,i+1);
         int ttdiff=MathAbs(t2-t1);
         if ((ttdiff!=(tfc*60)) && (ttdiff!=176400) && (ttdiff!=180000))
         {
            tk1=TimeToStr(t1,TIME_DATE|TIME_MINUTES);  
            tk2=TimeToStr(t2,TIME_DATE|TIME_MINUTES);
            Print("History ERROR: ",ap,"/",tfc,"/",i," tcurr: ", tk2, "/",tk1, " diff: ", ttdiff,"/", ttdiff/60);
            comm_tech_history=comm_tech_history+"History ERROR: "+ap+"/"+tfc+"/"+i+" date: "+tk2+" - "+tk1+" diff: "+ttdiff+"/"+ttdiff/60+"\n";
            //History ERROR: GBPNZD/60/119 tcurr: 2010.10.08 07:00/2010.10.08 09:00 diff: 7200/120
            //History ERROR: NZDCHF/60/119 tcurr: 2010.10.08 07:00/2010.10.08 09:00 diff: 7200/120
            //History ERROR: GBPUSD/60/0 tcurr: 2010.10.15 15:00/2010.10.15 19:00 diff: 14400/240
         }
         else
         {
            //Print("Hist OK: ",ap,"/",tfc,"/",x,"/",tk0, " LBT: ", hck[x], " tcurr: ", tt, " (",tk1," diff: ", tt-hck[x], " tfc: ", tfc*60);
         }
      }
   }

   Print("-----------------------------------------");

   H1R_E=0; H1R_S=0;
   H1S_E=0; H1S_S=0;

   ArrayInitialize(PPs,0);
   ArrayInitialize(cpr,0);
   ArrayInitialize(currentbar2,0);
   ArrayInitialize(currentbar3,0);

   ArrayInitialize(SR6S,0);
   ArrayInitialize(SR6R,0);
   ArrayInitialize(SR7S,0);
   ArrayInitialize(SR7R,0);

   ArrayInitialize(trtr,0);

   if (!IsConnected()) { start(); }
   //opordlog();
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+

void trtrlog()
{
   for (int ti=1;ti<100;ti++)
   {
      if ((trtr[ti][4]==0) && (trtr[ti][1]>0))
      {
         int t3=trtr[ti][2];
         int t4=trtr[ti][3];
         double tv=MarketInfo(Symbol(), MODE_TICKVALUE);
         Print("H1TL DATA: Ticket: ", trtr[ti][1], ", ", tpairs[t3], " (",trtr[ti][2],") / TF: ", trtr[ti][3], "(",TFns[t4],") MIN: ", trtr[ti][5], " MAX: ", trtr[ti][6], " MIN 2: ", trtr[ti][7],  " LAST: ", trtr[ti][8], " TV: ",DoubleToStr(tv,Digits), "\nSETUP: ", trts[ti][1]);
         trts[ti][1]="";
         trtr[ti][1]=0;
         trtr[ti][2]=0;
         trtr[ti][3]=0;
         trtr[ti][4]=0;
         trtr[ti][5]=0;
         trtr[ti][6]=0;
         trtr[ti][7]=0;
         trtr[ti][8]=0;
      }
   }
   return(0);
}

int deinit()
{
   objdel();
   trtrlog();
   return(0);
}

//+------------------------------------------------------------------+
//| Pivots function                                                  |
//+------------------------------------------------------------------+

void npivp(string ap)
{
   ArrayInitialize(PPs,0);
   double yesterday_high=0;
   double yesterday_open=0;
   double yesterday_low=0;
   double yesterday_close=0;
   double P=0;
   double R1,R2,R3;
   double S2.5,S1.5,S0.5,R0.5,R1.5,R2.5;
   double S1,S2,S3;

   R1=0; R2=0; R3=0;
   S2.5=0; S1.5=0; S0.5=0; R0.5=0; R1.5=0; R2.5=0;
   S1=0; S2=0; S3=0;

   //---- Get new daily prices
   if (PivotBrokerTime)
   {
      yesterday_close = iClose(ap, PERIOD_D1, 1);
      yesterday_open = iOpen(ap, PERIOD_D1, 1);
      yesterday_high = iHigh(ap, PERIOD_D1, 1);
      yesterday_low = iLow(ap, PERIOD_D1, 1);
   }
   else 
   {
      int pt0=0;
      for (int jt=0; jt < 24; jt++)
      {
         string tk1h=StringSubstr(TimeToStr(iTime(ap, PERIOD_H1, jt),TIME_MINUTES),0,5);
         if (tk1h==PivotStartingHour)
         { 
            pt0=jt; 
            jt=50; 
         }
      }
      pt0++;
      jt=pt0;

      string tk1h_0=StringSubstr(TimeToStr(iTime(ap, PERIOD_H1, jt+23),TIME_MINUTES),0,5);
      string tk1h_1=StringSubstr(TimeToStr(iTime(ap, PERIOD_H1, jt),TIME_MINUTES),0,5);

      double pop=iOpen(ap,PERIOD_H1,jt+23);
      double pcl=iClose(ap,PERIOD_H1,jt);
      double phigh = iHigh(ap, PERIOD_H1, iHighest(ap, PERIOD_H1, MODE_HIGH, 23, jt ) ); // Pivot Day high
      double plow = iLow(ap, PERIOD_H1, iLowest(ap, PERIOD_H1, MODE_LOW, 23, jt ) );     // Pivot Day low      

      yesterday_close = pcl;
      yesterday_open = pop;
      yesterday_high = phigh;
      yesterday_low = plow;
   }

// -------------------------------------------------------

   P = (yesterday_high + yesterday_low + yesterday_close) / 3;
   R1 = (2*P)-yesterday_low;
   S1 = (2*P)-yesterday_high;
   R2 = P+(yesterday_high - yesterday_low);
   S2 = P-(yesterday_high - yesterday_low);

	R3 = (2*P)+(yesterday_high-(2*yesterday_low));
	S3 = (2*P)-((2* yesterday_high)-yesterday_low);

   if (UseMidPivots)
   {
      R2.5 = (R2+R3)/2; R1.5 = (R1+R2)/2; R0.5 = (P+R1)/2; S0.5 = (P+S1)/2; S1.5 = (S1+S2)/2; S2.5 = (S2+S3)/2;
      PPs[2][1]=S2.5; PPs[4][1]=S1.5; PPs[6][1]=S0.5; PPs[8][1]=R0.5; PPs[10][1]=R1.5; PPs[12][1]=R2.5;
	}
   PPs[1][1]=S3; PPs[3][1]=S2; PPs[5][1]=S1; PPs[7][1]=P; PPs[9][1]=R1; PPs[11][1]=R2; PPs[13][1]=R3;

   // ----------------------------------------------------------------------
   // --- weekly ---

   yesterday_close = iClose(ap, PERIOD_W1, 1);
   yesterday_open = iOpen(ap, PERIOD_W1, 1);
   yesterday_high = iHigh(ap, PERIOD_W1, 1);
   yesterday_low = iLow(ap, PERIOD_W1, 1);

   //---- Calculate Pivots

   P = (yesterday_high + yesterday_low + yesterday_close) / 3;
   R1 = (2*P)-yesterday_low;
   S1 = (2*P)-yesterday_high;
   R2 = P+(yesterday_high - yesterday_low);
   S2 = P-(yesterday_high - yesterday_low);

	R3 = (2*P)+(yesterday_high-(2*yesterday_low));
	S3 = (2*P)-((2* yesterday_high)-yesterday_low);

   if (UseMidPivots)
   {
      R2.5 = (R2+R3)/2; R1.5 = (R1+R2)/2; R0.5 = (P+R1)/2; S0.5 = (P+S1)/2; S1.5 = (S1+S2)/2; S2.5 = (S2+S3)/2;
      PPs[2][2]=S2.5; PPs[4][2]=S1.5; PPs[6][2]=S0.5; PPs[8][2]=R0.5; PPs[10][2]=R1.5; PPs[12][2]=R2.5;
	}
   PPs[1][2]=S3; PPs[3][2]=S2; PPs[5][2]=S1; PPs[7][2]=P; PPs[9][2]=R1; PPs[11][2]=R2; PPs[13][2]=R3;

   // --- monthly ---
   yesterday_close = iClose(ap, PERIOD_MN1, 1);
   yesterday_open = iOpen(ap, PERIOD_MN1, 1);
   yesterday_high = iHigh(ap, PERIOD_MN1, 1);
   yesterday_low = iLow(ap, PERIOD_MN1, 1);

   //---- Calculate Pivots

   P = (yesterday_high + yesterday_low + yesterday_close) / 3;
   R1 = (2*P)-yesterday_low;
   S1 = (2*P)-yesterday_high;
   R2 = P+(yesterday_high - yesterday_low);
   S2 = P-(yesterday_high - yesterday_low);

	R3 = (2*P)+(yesterday_high-(2*yesterday_low));
	S3 = (2*P)-((2* yesterday_high)-yesterday_low);

   if (UseMidPivots)
   {
      R2.5 = (R2+R3)/2; R1.5 = (R1+R2)/2; R0.5 = (P+R1)/2; S0.5 = (P+S1)/2; S1.5 = (S1+S2)/2; S2.5 = (S2+S3)/2;
      PPs[2][3]=S2.5; PPs[4][3]=S1.5; PPs[6][3]=S0.5; PPs[8][3]=R0.5; PPs[10][3]=R1.5; PPs[12][3]=R2.5;
   }
   PPs[1][3]=S3; PPs[3][3]=S2; PPs[5][3]=S1; PPs[7][3]=P; PPs[9][3]=R1; PPs[11][3]=R2; PPs[13][3]=R3;

   // ----------------------------------------------------------------------

   int mp=0;
   for (int tt=1;tt<14;tt++)
   {
      mp=1-mp;
      for (int tt2=1;tt2<4;tt2++)
      {
         //Print(ap, " t1: ", tt, " t2: ", tt2, " PP: ", PPTFn[tt2]+PPn[tt]," ", DoubleToStr(PPs[tt][tt2],Digits));
         color PPc=PPcol[tt];
         if (tt2>1) { PPc=Gray; }
         if ((mp==1) || (UseMidPivots))
         {
            if(ObjectFind(PPTFn[tt2]+PPn[tt]+" Label") != 0)
            {
               ObjectCreate(PPTFn[tt2]+PPn[tt]+" Label", OBJ_TEXT, 0, Time[20], PPs[tt][tt2]);
               ObjectSetText(PPTFn[tt2]+PPn[tt]+" Label", PPTFn[tt2]+PPn[tt], 8, "Arial", White);
            }
            else
            {
               ObjectMove(PPTFn[tt2]+PPn[tt]+" Label", 0, Time[20], PPs[tt][tt2]);
            }
         }

         if (mp==1)
         {
            if (ObjectFind(PPTFn[tt2]+PPn[tt]+" Line") != 0)
            {
               ObjectCreate(PPTFn[tt2]+PPn[tt]+" Line", OBJ_HLINE, 0, Time[40], PPs[tt][tt2]);
               ObjectSet(PPTFn[tt2]+PPn[tt]+" Line", OBJPROP_STYLE, STYLE_DASH);
               ObjectSet(PPTFn[tt2]+PPn[tt]+" Line", OBJPROP_COLOR, PPc);
            }
            else
            {
               ObjectMove(PPTFn[tt2]+PPn[tt]+" Line", 0, Time[40], PPs[tt][tt2]);
            }
         }
         else
         {
            if (UseMidPivots)
            {
               if(ObjectFind(PPTFn[tt2]+PPn[tt]+" Line") != 0)
               {
                  ObjectCreate(PPTFn[tt2]+PPn[tt]+" Line", OBJ_HLINE, 0, Time[40], PPs[tt][tt2]);
                  ObjectSet(PPTFn[tt2]+PPn[tt]+" Line", OBJPROP_STYLE, STYLE_DOT);
                  ObjectSet(PPTFn[tt2]+PPn[tt]+" Line", OBJPROP_COLOR,  PPc);
               }
               else
               {
                  ObjectMove(PPTFn[tt2]+PPn[tt]+" Line", 0, Time[40], PPs[tt][tt2]);
               }
            }
         }
      }
   }
   WindowRedraw();
}

//+------------------------------------------------------------------+
//| Pivots function                                                  |
//+------------------------------------------------------------------+

int getpairnr(string ap)
{
   for (int np=1;np<35;np++)
   {
      if (ap==tpairs[np]) { return(np); }
      if (StringFind(ap, tpairs[np], 0)>=0) { return(np); }
      if (StringFind(Symbol(), tpairs[np], 0)>=0) { return(np); }
   }
   return(0);
}

int makemagicnr(int apnr, int otp)
{
   // otp: OrderType 1,2,3,4
   int mgnp=apnr;
   int mgnt=0;
   int mg=MagicNRMin+mgnp*100+mgnt*10+otp;
   return(mg);
}

int OpenOrder(int otp, string mcomment, int MagicNumber, double StopLossLevel, double TakeProfitLevel, double bsp)
{
   int otc=0;
   int Ticket=0;
   int oc=0;
   //Check free margin
   if (AccountFreeMargin() < (1000 * Lots))
   {
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
   RefreshRates();
   double t_spread=MarketInfo(Symbol(), MODE_SPREAD);

//   if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
//   if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;
                  
   Print("New order: ",Symbol()," @ ASK: ", DoubleToStr(Ask,Digits), " SPREAD: ", DoubleToStr(t_spread,0), " MAGIC: ", MagicNumber, " SL: ", StopLossLevel, " TP: ", TakeProfitLevel);

   if (otp==OP_BUY)
   {
      Ticket = OrderSend(Symbol(), OP_BUY, Lots, NormalizeDouble(Ask,Digits), Slippage, 0, 0, mcomment, MagicNumber, 0, DodgerBlue);
      oc=DodgerBlue;
   }
   if (otp==OP_SELL)
   {
      Ticket = OrderSend(Symbol(), OP_SELL, Lots, NormalizeDouble(Bid,Digits), Slippage, 0, 0, mcomment, MagicNumber, 0, DeepPink);
      oc=DeepPink;
   }
   if (otp==OP_BUYSTOP)
   {
      Ticket = OrderSend(Symbol(), OP_BUYSTOP, Lots, NormalizeDouble(bsp,Digits), Slippage, 0, 0, mcomment, MagicNumber, 0, DodgerBlue);
      oc=DodgerBlue;
   }
   if (otp==OP_SELLSTOP)
   {
      Ticket = OrderSend(Symbol(), OP_SELLSTOP, Lots, NormalizeDouble(bsp,Digits), Slippage, 0, 0, mcomment, MagicNumber, 0, DeepPink);
      oc=DeepPink;
   }
   if(Ticket > 0)
   {
      int ti=findti2(otc);
      trtr[ti][1]=otc;
      trtr[ti][4]=1;
      trts[ti][1]=comm2;
      otc=Ticket;
      if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES))
      {
         if ((StopLossLevel!=0) || (TakeProfitLevel!=0))
         {
            tmi1=OrderModify(OrderTicket(),OrderOpenPrice(), NormalizeDouble(StopLossLevel,Digits), NormalizeDouble(TakeProfitLevel,Digits),0, oc);
            if (!tmi1) { errorlog1(StopLossLevel, TakeProfitLevel, 1); }
         }
         //if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
		} else {
	     Print("Error opening order : ", ErrorDescription(GetLastError()));
	  }
   }
   return(otc);
}

int FindNextSwing(string ap, int tfc, double pr, int dir, int minsh)
{
   // dir: 1: Swing Low, 2 Swing High
   bool megvan=false;
   int megvan_s=-1;
   double price=0;
   bool fractal;
   //int st=0;
   int st=minsh+1;
   int nb=iBars(ap, tfc);
   while(!megvan)
   {
      if (dir==1)
      {
         // Support
         price = iLow(ap,tfc,st+1);
         if (price<pr)
         {
            fractal = price < iLow(ap,tfc,st) && price < iLow(ap,tfc,st+2);
         }
      }
      if (dir==2)
      {
         // Resistance
         price = iHigh(ap,tfc,st+1);
         if (price>pr)
         {
            fractal = price > iHigh(ap,tfc,st) && price > iHigh(ap,tfc,st+2);
         }
      }
              
      if (fractal)
      {
         megvan_s=st+1;
         megvan=true;
      }
      st++;
      if (st>nb-3) { megvan=true; megvan_s=-1; }
   }
   return(megvan_s);
}

double getnextpp(double pnow, int mode)
{
   // mode: 1: higher, 2: lower
   // ptf: 1: daily, 2: weekly, 3: monthly
   double nextpp=0;
   double np1=0;
   if (mode==1)
   {
      for (int tt=1;tt<14;tt++)
      {
         for (int tt2=1;tt2<4;tt2++)
         {
            np1=PPs[tt][tt2];
            if ((tt2==2) && (!UseWeeklyPivots)) { np1=0; }
            if ((tt2==3) && (!UseMonthlyPivots)) { np1=0; }
            if (np1>0)
            {
               if (np1>pnow)
               {
                  if ((nextpp==0) || (np1<nextpp)) { nextpp=np1; }
               }
            }
         }
      }
   }
   np1=0;
   if (mode==2)
   {
      for (tt=1;tt<14;tt++)
      {
         for (tt2=1;tt2<4;tt2++)
         {
            np1=PPs[tt][tt2];
            if ((tt2==2) && (!UseWeeklyPivots)) { np1=0; }
            if ((tt2==3) && (!UseMonthlyPivots)) { np1=0; }
            if (np1>0)
            {
               if (np1<pnow)
               {
                  if ((nextpp==0) || (np1>nextpp)) { nextpp=np1; }
               }
            }
         }
      }
   }
   return(nextpp);
}

int ChkMADir(string ap, int tfc, int sh)
{
   double fMA = iMA(ap, tfc, MTF2_MA_Period_Fast, 0, MTF2_MA_Type, PRICE_CLOSE, sh);
   double sMA = iMA(ap, tfc, MTF2_MA_Period_Slow, 0, MTF2_MA_Type, PRICE_CLOSE, sh);

   int keres=0;
   if (fMA>sMA) { keres=1; }  // BUY
   if (fMA<sMA) { keres=2; }  // SELL
   //Print(ap,"/",tfc,"/",sh," MA F: ", fMA, " S: ", sMA, " dir: ", keres);
   return(keres);
}

int ChkPRMADir(string ap, int tfc, int sh)
{
   double fMA = iMA(ap, tfc, MTF3_MA_Period, 0, MTF3_MA_Type, PRICE_CLOSE, sh);
   double prc = iClose(ap, tfc, sh);
   int keres=0;
   if (fMA<prc) { keres=1; }  // BUY
   if (fMA>prc) { keres=2; }  // SELL
   //Print(ap,"/",tfc,"/",sh," MA F: ", fMA, " S: ", sMA, " dir: ", keres);
   return(keres);
}

int ChkPPMADir(string ap, int tfc, int sh)
{
   double fMA = iMA(ap, tfc, 1, 0, MODE_SMA, PRICE_TYPICAL, sh);
   double sMA = iMA(ap, tfc, 3, 0, MODE_SMA, PRICE_TYPICAL, sh);

   int keres=0;
   if (fMA>sMA) { keres=1; }  // BUY
   if (fMA<sMA) { keres=2; }  // SELL
   //Print(ap,"/",tfc,"/",sh," PPMA F: ", fMA, " S: ", sMA, " dir: ", keres);
   return(keres);
}

int ChkMACDDir(string ap, int tfc, int sh)
{
   double mcm = iMACD(ap, tfc, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, sh);
   int keres=0;
   if (mcm>0) { keres=1; }  // BUY
   if (mcm<0) { keres=2; }  // SELL

   // if (mcm>(MACDHistLevel)) { keres=1; }  // BUY
   // if (mcm<(MACDHistLevel*-1)) { keres=2; }  // SELL
   return(keres);
}

int ChkMACDDir2(string ap, int tfc, int sh)
{
   double mcm = iMACD(ap, tfc, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, sh);
   double mcs = iMACD(ap, tfc, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL, sh);

   int keres=0;
   if (mcm>mcs) { keres=1; }  // BUY
   if (mcm<mcs) { keres=2; }  // SELL
   // Print(ap,"/",tfc,"/",sh," MACD main: ", mcm, " signal: ", mcs, " dir: ", keres);
   return(keres);
}

int ChkCCIDir(string ap, int tfc, int sh)
{
   double mcm = iCCI(ap, tfc, CCITrendFilterPeriod, PRICE_CLOSE, sh);
   int keres=0;
   if (mcm>100) { keres=1; }  // BUY
   if (mcm<-100) { keres=2; }  // SELL
   return(keres);
}

int ChkRSIDir(string ap, int tfc, int sh)
{
   double mcm = iRSI(ap, tfc, RSITrendFilterPeriod, PRICE_CLOSE, sh);
   int keres=0;
   if (mcm>=50) { keres=1; }  // BUY
   if (mcm<50) { keres=2; }  // SELL
   return(keres);
}

void TLSwingMap(string ap, int tfc, int tfnr)
{
   double smin=10000, smax=0;
   int st=1;
   int shc=1, slc=1;
   int nbars=iBars(ap, tfc)-2;
   bool kmiout=false, kmaout=false;
   _H1R_E[tfnr]=0; _H1S_E[tfnr]=0;
   _H1R_S[tfnr]=0; _H1S_S[tfnr]=0;

   while(st<nbars)
   {
      // Support
      double pricel = iLow(ap,tfc,st+1);
//      Print(ap,"/",tfc, "(",st,") PL: ", DoubleToStr(pricel,5));
      if (!kmiout)
      {
         if ((pricel < iLow(ap,tfc,st+2)) && (pricel < iLow(ap,tfc,st)))
         {
            if (_H1S_E[tfnr]==0) { _H1S_E[tfnr]=st+1; smin=pricel; }
            if ((_H1S_E[tfnr]>0) && (_H1S_S[tfnr]==0) && (pricel<smin)) { _H1S_S[tfnr]=st+1; }
         }
         if ((_H1S_E[tfnr]>0) && (_H1S_S[tfnr]>0))
         {
            kmiout=true;
         }
      }
      // Resistance
      double priceh = iHigh(ap,tfc,st+1);
//      Print(ap,"/",tfc, "(",st,") PH: ", DoubleToStr(priceh,5));
      if (!kmaout)
      {
         if ((priceh > iHigh(ap,tfc,st+2)) && (priceh > iHigh(ap,tfc,st)))
         {
            if (_H1R_E[tfnr]==0) { _H1R_E[tfnr]=st+1; smax=priceh; }
            if ((_H1R_E[tfnr]>0) && (_H1R_S[tfnr]==0) && (priceh>smax)) { _H1R_S[tfnr]=st+1; }
         }
         if ((_H1R_E[tfnr]>0) && (_H1R_S[tfnr]>0))
         {
            kmaout=true;
         }
      }
      if (kmiout && kmaout) { st=nbars+1; }
      st++;
   }

   // if (H1S_S[tfnr]==0) { H1S_E[tfnr]=0; }
   // if (H1R_S[tfnr]==0) { H1R_E[tfnr]=0; }
   // if (H1S_E[tfnr]==0) { H1S_S[tfnr]=0; }
   // if (H1R_E[tfnr]==0) { H1R_S[tfnr]=0; }
   
   Print(ap,"/",tfc, " TL S: 1: ", _H1S_E[tfnr], " , 2: ", _H1S_S[tfnr]);
   Print(ap,"/",tfc, " TL R: 1: ", _H1R_E[tfnr], " , 2: ", _H1R_S[tfnr]);

   _h1[tfnr]=_H1R_E[tfnr]; _h2[tfnr]=_H1R_S[tfnr]; 
   _l1[tfnr]=_H1S_E[tfnr]; _l2[tfnr]=_H1S_S[tfnr];
   _hh1[tfnr]=0; _hh2[tfnr]=0; _ll1[tfnr]=0; _ll2[tfnr]=0;
   _TLBU[tfnr]=0; _TLBD[tfnr]=0;

   if ((_h1[tfnr]>0) && (_h2[tfnr]>0))
   {
      _hh1[tfnr]=iHigh(ap, tfc, _h1[tfnr]); 
      _hh2[tfnr]=iHigh(ap, tfc, _h2[tfnr]);
//      TLBU=hh2-(hh2-hh1)/(h2-h1)*h2;
      _TLBU[tfnr]=0;
      if ((_h2[tfnr]>0) && (_h1[tfnr]>0))
      {
         _TLBU[tfnr]=_hh2[tfnr]-(_hh2[tfnr]-_hh1[tfnr])/(_h2[tfnr]-_h1[tfnr])*_h2[tfnr];
      }
   }
   if ((_l1[tfnr]>0) && (_l2[tfnr]>0))
   {
      _ll1[tfnr]=iLow(ap, tfc, _l1[tfnr]); 
      _ll2[tfnr]=iLow(ap, tfc, _l2[tfnr]);
//      TLBD=ll2+(ll1-ll2)/(l2-l1)*l2;
      _TLBD[tfnr]=0;
      if ((_l2[tfnr]>0) && (_l1[tfnr]>0))
      {
         _TLBD[tfnr]=_ll2[tfnr]+(_ll1[tfnr]-_ll2[tfnr])/(_l2[tfnr]-_l1[tfnr])*_l2[tfnr];
      }
   }
   Print(ap, " HTF H1: ", _h1[tfnr], " H2: ", _h2[tfnr], " L1: ", _l1[tfnr], " L2: ", _l2[tfnr]);
   Print(ap, " HTF HH1: ", _hh1[tfnr], " HH2: ", _hh2[tfnr], " LL1: ", _ll1[tfnr], " LL2: ", _ll2[tfnr]);
   Print(ap, " HTF TLBU: ",DoubleToStr(_TLBU[tfnr],5)," | TLBD: ",DoubleToStr(_TLBD[tfnr],5));

   // TLBU=hh2-(((hh2-hh1)/(h2-h1))*h2);
   // TLBD=ll2+(((ll1-ll2)/(l2-l1))*l2);
   // meredeksg/ 1 candle: (hh2-hh1)/(h2-h1)  
   Print ("-----------------------------------------------");

   if (DisplayHTLs)
   {
      if ((tfc==60) || (tfc==240) || (tfc==1440) || (tfc==10080))
      {
         ArrayCopyRates(rate_array, ap, tfc);
         if (tfc==60)
         {
            DrawTrendline ("H1_R", _h1[tfnr], _h2[tfnr], tfc, RESISTANCE, rate_array);
            DrawTrendline ("H1_S", _l1[tfnr], _l2[tfnr], tfc, SUPPORT, rate_array);
         }
         if (tfc==240)
         {
            DrawTrendline ("H4_R", _h1[tfnr], _h2[tfnr], tfc, RESISTANCE, rate_array);
            DrawTrendline ("H4_S", _l1[tfnr], _l2[tfnr], tfc, SUPPORT, rate_array);
         }
         if (tfc==1440)
         {
            DrawTrendline ("D1_R", _h1[tfnr], _h2[tfnr], tfc, RESISTANCE, rate_array);
            DrawTrendline ("D1_S", _l1[tfnr], _l2[tfnr], tfc, SUPPORT, rate_array);
         }
         if (tfc==10080)
         {
            DrawTrendline ("W1_R", _h1[tfnr], _h2[tfnr], tfc, RESISTANCE, rate_array);
            DrawTrendline ("W1_S", _l1[tfnr], _l2[tfnr], tfc, SUPPORT, rate_array);
         }
      }
   }
}

void ibld(string objn, datetime t1, double p1, datetime t2, double p2, color linecolor, int thickness)
{
   int line_style = 2;
   //color linecolor = Silver;
   ObjectCreate(objn, OBJ_TREND, 0, t1, p1, t2, p2);
   ObjectSet(objn, OBJPROP_STYLE, line_style);
   ObjectSet(objn, OBJPROP_WIDTH, thickness);
   ObjectSet(objn, OBJPROP_COLOR, linecolor);
   ObjectSet(objn, OBJPROP_BACK, TRUE);
}

void ibbd(string objn, datetime t1, double p1, datetime t2, double p2, color boxcolor)
{
   //color boxcolor1 = C'0x00,0x00,0x4F';
   //color boxcolor2 = MidnightBlue;
   //color boxcolor3 = Red;
   ObjectCreate(objn, OBJ_RECTANGLE, 0, t1, p1, t2, p2);
   ObjectSet(objn, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(objn, OBJPROP_COLOR, boxcolor);
   ObjectSet(objn, OBJPROP_BACK, TRUE);
}

int ChkRanging(string ap, int tfc, int tfnr)
{
   cpr[tfnr][1]=0;  // start
   cpr[tfnr][2]=0;  // min, low
   cpr[tfnr][3]=0;  // max, high
   int prs=0;
   double h0=0, l0=0, h1=0, l1=0, h2, l2, o1, c1, rh=0, rl=0;
   datetime t0, t1, t2;
   for (int rd=100;rd>1;rd--)
   {
      h0=iHigh(ap, tfc, rd);
      l0=iLow(ap, tfc, rd);
      h1=iHigh(ap, tfc, rd-1);
      l1=iLow(ap, tfc, rd-1);
      if (h0>h1 && l0<l1)  // inside bar
      {
         //Print(ap, "/",tfc," ST IB: RD: ",rd);
         //prs=rd; rh=h1; rl=l1;  // rossz volt: h0, l0
         prs=rd; rh=h0; rl=l0;  // nem volt rossz: h0, l0
         bool inrg=true;
         int ssh=rd-1;
         int rs=0, re=0, rc=1;
         while (inrg)
         {
            //Print(ap, "/",tfc," CC IB: RD: ",rd, " SSH: ", ssh);
            h2=iHigh(ap, tfc, ssh+1);
            l2=iLow(ap, tfc, ssh+1);
            h1=iHigh(ap, tfc, ssh);
            l1=iLow(ap, tfc, ssh);

            if ((rh<h2) && (rl>l2) && (h2>h1) && (l2<l1))
            {
               rh=h2; rl=l2; prs=ssh+1;
            }
            o1=iOpen(ap, tfc, ssh);
            c1=iClose(ap, tfc, ssh);
            
            if ((o1<rh) && (o1>rl) || ((c1<rh) && (c1>rl)))
            {
               rc++;
            } else {
               prs=0; rh=0; rl=0;
               inrg=false;
            }
            ssh--;
            if ((ssh<1) && (inrg)) { rd=0; }
            if (ssh<1) { inrg=false; }
         }
      }
   }

   if ((tfc==60) || (tfc==240) || (tfc==1440) || (tfc==10080))
   {
      string on1="";
      if (tfc==60) { on1="H1"; }
      if (tfc==240) { on1="H4"; }
      if (tfc==1440) { on1="D1"; }
      if (tfc==10080) { on1="W1"; }
      ObjectDelete("IB-box-"+on1);
      ObjectDelete("IB-lineH-"+on1);
      ObjectDelete("IB-lineL-"+on1);
      if (rh>0)
      {
         cpr[tfnr][1]=prs;  // start
         cpr[tfnr][2]=rl;   // min, low
         cpr[tfnr][3]=rh;   // max, high
         if (DisplayInsideBars)
         {
            if ((tfc==60) || (tfc==240) || (tfc==1440) || (tfc==10080))
            {
               t0=iTime(ap, tfc, 0);
               t1=iTime(ap, tfc, prs-1);
               t2=iTime(ap, tfc, prs);
               ibbd("IB-box-"+on1, t1, rh, t2, rl, MidnightBlue);
               ibld("IB-lineH-"+on1, t2, rh, t0, rh, Silver, 1);
               ibld("IB-lineL-"+on1, t2, rl, t0, rl, Silver, 1);
            }
         }
      }
   }
}

int ChkSidewaysPattern(string ap, int tfc, int tfnr)
{
   cps[tfnr][1]=0;  // start
   cps[tfnr][2]=0;  // min, low
   cps[tfnr][3]=0;  // max, high
   int prs=0;
   int swpc=0;
   double h0=0, l0=0, h1=0, l1=0, h2, l2, o1, c1, rh=0, rl=0;
   datetime t0, t1, t2;
   for (int rd=100;rd>3;rd--)
   {
      h0=iHigh(ap, tfc, rd);
      l0=iLow(ap, tfc, rd);
      o1=iOpen(ap, tfc, rd-1);
      c1=iClose(ap, tfc, rd-1);
      if ((o1<h0 && o1>l0) || (c1<h0 && c1>l0))    // open or close within prev.bar
      {
         //Print(ap, "/",tfc," ST IB: RD: ",rd);
         prs=rd; rh=h0; rl=l0;
         bool inrg=true;
         int ssh=rd-2;
         int rs=0, re=0, rc=2;
         while (inrg)
         {
            //Print(ap, "/",tfc," CC IB: RD: ",rd, " SSH: ", ssh);
            o1=iOpen(ap, tfc, ssh);
            c1=iClose(ap, tfc, ssh);
            
            if ((o1<h0) && (o1>l0) || ((c1<h0) && (c1>l0)))
            {
               rc++;
            } else {
               prs=0; rh=0; rl=0;
               inrg=false;
            }
            ssh--;
            if ((ssh<1) && (inrg)) { rd=0; }
            if (ssh<1) { inrg=false; }
         }
      }
   }
   if (rc<4) { prs=0; rh=0; rl=0; }

   if ((tfc==60) || (tfc==240) || (tfc==1440) || (tfc==10080))
   {
      string on1="";
      if (tfc==60) { on1="H1"; }
      if (tfc==240) { on1="H4"; }
      if (tfc==1440) { on1="D1"; }
      if (tfc==10080) { on1="W1"; }
      ObjectDelete("SW-box-"+on1);
      ObjectDelete("SW-lineH-"+on1);
      ObjectDelete("SW-lineL-"+on1);
      if (rh>0)
      {
         cps[tfnr][1]=prs;  // start
         cps[tfnr][2]=rl;   // min, low
         cps[tfnr][3]=rh;   // max, high
         if (DisplaySidewaysPattern)
         {
            if ((tfc==60) || (tfc==240) || (tfc==1440) || (tfc==10080))
            {
               t0=iTime(ap, tfc, 0);
               t1=iTime(ap, tfc, prs-1);
               t2=iTime(ap, tfc, prs);
               ibbd("SW-box-"+on1, t1, rh, t2, rl, Red);
               ibld("SW-lineH-"+on1, t2, rh, t0, rh, Silver, 1);
               ibld("SW-lineL-"+on1, t2, rl, t0, rl, Silver, 1);
            }
         }
      }
   }
}

void filterinfo(string ap)
{
   ArrayInitialize(MTFc,-1);
   ArrayInitialize(MTFs,-1);
   ArrayInitialize(MTFs,0);
   int i=0, j=0, k=0;
   for(i=1;i<10;i++)  // filters
   {
      if (MTFCheck[i]) { MTFi[i]=MTFn[i]+" ON "; } else { MTFi[i]=MTFn[i]+" OFF "; }
      MTFii[i]="";
      int tr3i=0;
      for(j=1;j<10;j++)  // TFs
      {
         if (MTFCheck2[j])
         {
            string tr1="UP";
            string tr2="DN";
            string tr3="--";
            for(k=0;k<2;k++)  // shift
            {
               int cr=0;
               if (i==1) { cr=ChkPPMADir(ap, TFs[j], k); }
               if (i==2) { cr=ChkMADir(ap, TFs[j], k); }
               if (i==3) { cr=ChkPRMADir(ap, TFs[j], k); }
               if (i==4) { cr=ChkMACDDir(ap, TFs[j], k); }
               if (i==5) { cr=ChkMACDDir2(ap, TFs[j], k); }
               if (i==6) { cr=ChkRSIDir(ap, TFs[j], k); }
               if (i==7) { cr=ChkCCIDir(ap, TFs[j], k); }
               MTFc[i][j][k]=cr;
               if (cr!=1) { tr1=""; }
               if (cr!=2) { tr2=""; }
            }
            tr3=tr1+tr2;
            if (tr3=="") { tr3="--"; MTFsc[i][0]++; tr3i=-1; }
            if (tr3=="UP") { MTFsc[i][1]++; if ((tr3i==0) || (tr3i==1)) { tr3i=1; } else { tr3i=-1; } }
            if (tr3=="DN") { MTFsc[i][2]++; if ((tr3i==0) || (tr3i==2)) { tr3i=2; } else { tr3i=-1; } }
            MTFii[i]=MTFii[i]+" | "+TFns[j]+": "+tr3;
            if ((j==5) && (HTFCheck[i] & 1)) { MTFs[i]=tr3i; }
            if ((j==6) && (HTFCheck[i] & 2)) { MTFs[i]=tr3i; }
            if ((j==7) && (HTFCheck[i] & 4)) { MTFs[i]=tr3i; }
         }
      }
      MTFi[i]=MTFi[i]+MTFii[i];
      if (MTFCheck[i]) { MTFi[i]=MTFi[i]+" (R: "+MTFs[i]+")"; }
      MTFi[i]=MTFi[i]+"\n";
   }
}

bool checkorderhist(string ap)
{
   bool megvan=false;
   int Total = OrdersHistoryTotal();
   for (int i = 0; i < Total; i ++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
      string oap=OrderSymbol();
      if (oap==ap)
      {
         int omnr=OrderMagicNumber();
         //if((omnr>MagicNRMin) && (omnr<MagicNRMax) && ((OrderType()+1)==bos))
         if ((omnr==mmnr1) || (omnr==mmnr2) || (omnr==mmnr3) || (omnr==mmnr4))
         {
            if (OrderOpenTime()>iTime(Symbol(),PERIOD_D1,0))
            {
               if((OrderType()+1)==1) { NoBuyToday=true;}
               if((OrderType()+1)==2) { NoSellToday=true;}
               megvan=true;
               i=Total+1;
            }
         }
      }
   }
   return(megvan);
}

bool checkopenorder(string ap, int bos, int mmnr)
{
   bool megvan=false;
   int Total = OrdersTotal();
   for (int i = 0; i<Total; i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      string oap=OrderSymbol();
      if (oap==ap)
      {
         int omnr=OrderMagicNumber();
         //if((omnr>MagicNRMin) && (omnr<MagicNRMax) && ((OrderType()+1)==bos))
         if((omnr==mmnr) && ((OrderType()+1)==bos))
         {
            int mgnp=getpairnr(oap);
            tpo[OrderType()+1]=1;
            megvan=true;
            i=Total+1;
         }
      }
   }
   return(megvan);
}

string al0(int number, int digits){
  // add leading zeros that the resulting string has 'digits' length.
  string result;
  result = DoubleToStr(number, 0);
  while(StringLen(result)<digits) result = "0"+result;
  return(result);
}

void MakeScreenShot(string sx="")
{
   static int no=0;
   no++;
   string fn = "SnapShot-ADV5-"+Symbol()+Period()+"\\"+Symbol()+"-"+Period()+"-"+Year()+"-"+al0(Month(),2)+"-"+al0(Day(),2)+" "+al0(Hour(),2)+"_"+al0(Minute(),2)+"_"+al0(Seconds(),2)+" "+no+sx;
   if (!WindowScreenShot(fn+".gif",1280,1024)) Print("ScreenShot error: ", ErrorDescription(GetLastError()));
   //if (!WindowScreenShot(fn+"-0.gif",1280,1024,-1,0)) Print("ScreenShot error: ", ErrorDescription(GetLastError()));
   //if (!WindowScreenShot(fn+"-1.gif",1280,1024,-1,1)) Print("ScreenShot error: ", ErrorDescription(GetLastError()));
   return(0);
}

void opordlog()
{
   if (loggingenabled)
   {
      Print("\n----------------------\n",elog,"\n----------------------\n");
   }
   if (loggingsnapshot)
   {
      //int i=iCustom(Symbol(), Period(), "SnapShotI", 1, 1, true, 1280, 1024, 0, 0);
      MakeScreenShot("");
   }
   elog="";
   return(0);
}

void errorlog1(double sl, double tp, int id)
{ 
   Print("Error modifying order : ", ErrorDescription(GetLastError()));
   Print(Symbol(), "(",id,") ASK: ", DoubleToStr(Ask, Digits), " BID: ", DoubleToStr(Bid, Digits), " SL: ", DoubleToStr(sl, Digits), " TP: ", DoubleToStr(tp, Digits)); 
   return(0);
}

int findti2(int otck)
{
   int ti=0; int ti2=0; int nti2=0;
   for (ti=1;ti<100;ti++)
   {
      if (trtr[ti][1]==otck) { ti2=ti; ti=101; }
      if ((trtr[ti][1]==0) && (nti2==0)) { nti2=ti; }
   }
   if (ti2==0) { ti2=nti2; } 
   if (ti2==0)
   {
      for (ti=1;ti<100;ti++)
      {
         if (trtr[ti][1]==0) { ti2=ti; ti=101; }
      }
   }
   ti=ti2;
   return(ti);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;
   double pdiff=0;
   int t_spread;

   string ap=Symbol();
   int apnr=getpairnr(ap);
   int np=apnr;
   string apnr_s=DoubleToStr(np,0);
   if (np<10) { apnr_s="0"+apnr_s; }


   string mcom="";
   double SLLevel=0;
   double TPLevel=0;

   double bspr, sspr;

   // Print("ap: ", ap, " apnr: ", apnr, " s: ", apnr_s);

   elog="";
   int x=0, tfc=60;
   comm2="";
   bool Trade_tf=true;

   // if (EachTickMode && Bars != BarCount) TickCheck = False;

   Total = OrdersTotal();
   int Order = SIGNAL_NONE;

   //Check position
   bool IsTrade = False;
   
   // ----- trade management -----

   for (int i=0; i<Total; i++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

      int omnr=OrderMagicNumber();
      if((omnr>MagicNRMin) && (omnr<MagicNRMax) && (OrderSymbol()==Symbol()))
      {
         string oap=OrderSymbol();
         int opnr=getpairnr(oap);
         int otp=MathMod(omnr,10);
         int otc=OrderTicket();

         string tk0h=StringSubstr(TimeToStr(TimeCurrent(),TIME_MINUTES),0,5);  // MM.DD hh:mm  // ("01.01 00:00") 

         datetime inow=iTime(Symbol(),PERIOD_H1,0);
         datetime inow2=TimeCurrent();
         string inow_s=TimeToStr(inow,TIME_DATE|TIME_MINUTES);
         string inow2_s=TimeToStr(inow2,TIME_DATE|TIME_MINUTES);
         datetime iord=OrderOpenTime();
         string dtord=TimeToStr(iord,TIME_DATE|TIME_MINUTES);
         int diff=(inow-iord)/60;  // perc
         int t2over=0;
         int oopt_sh=(diff/60)+1;
         datetime iopt=iTime(Symbol(),PERIOD_H1,oopt_sh);
         string dtord2=TimeToStr(iopt,TIME_DATE|TIME_MINUTES);
         if (diff>2*60) { t2over=1; }
         double tbi=0;
         int ord1c=-1;

         datetime itm, itm2;

         if ((otp==1) || (otp==2))
         {
            int opordsh=100;
            for (int t=1;t<24;t++)
            {
               itm=iTime(oap, PERIOD_H1, t);
               itm2=iTime(oap, PERIOD_H1, t-1);
               double ipr=iClose(oap, PERIOD_H1, t);
               if ((iord>itm) && (iord<itm2)) { opordsh=t; oopt_sh=t; } 
               if (t<=opordsh)
               {
                  if ((OrderType()==OP_BUY) && (TLBU>0))
                  {
                     tbi=TLBU+(TLUM*t);
                     if (ipr>tbi)
                     { 
                        ord1c=t;
                        //Print(oap,"/",omnr," OTP: ",OrderType(), "(SH:",t,")  ord1c: ",ord1c," TBi(t): ", DoubleToStr(tbi,Digits), " IPR(t): ", DoubleToStr(ipr,Digits));
                     }
                  }
                  if ((OrderType()==OP_SELL) && (TLBD>0))
                  {
                     tbi=TLBD-(TLLM*t);
                     if (ipr<tbi)
                     {
                        ord1c=t;
                        //Print(oap,"/",omnr," OTP: ",OrderType(), "(SH:",t,")  ord1c: ",ord1c," TBi(t): ", DoubleToStr(tbi,Digits), " IPR(t): ", DoubleToStr(ipr,Digits));
                     }
                  }
               }
            }
            //Print(oap,"/",omnr," OTP: ",OrderType(), " OP.SH: ",opordsh," T2OVER 1st Shift: ",ord1c," TBi: ", DoubleToStr(tbi,Digits), " IPR: ", DoubleToStr(ipr,Digits));
            t2over=0;
            if (ord1c>2) { t2over=1; }
         }
      }
      
      if((omnr>MagicNRMin) && (omnr<MagicNRMax) && (OrderSymbol()==Symbol()))
      {
         if ((tk0h>LastTradingHour) && (UseTimeFilter))  // utols ra utn trail x pips
         {
            if (OrderType()==OP_BUYSTOP)
            {
               Print ("Delete Pending Buy Order (90): ",oap, " opnr: ",opnr, " Ticket: ", otc);
               tmi1=OrderDelete(otc);
               if (!tmi1) { errorlog1(sll, OrderTakeProfit(),90); }
            }
            if (OrderType()==OP_SELLSTOP)
            {
               Print ("Delete Pending Sell Order (91): ",oap, " opnr: ",opnr, " Ticket: ", otc);
               tmi1=OrderDelete(otc);
               if (!tmi1) { errorlog1(sll, OrderTakeProfit(),91); }
            }
         }
      }

      if((OrderType() <= OP_SELL) && (omnr>MagicNRMin) && (omnr<MagicNRMax) && (OrderSymbol()==Symbol()))
      {
         // IsTrade = True;
         if(OrderType() == OP_BUY)
         {
            //Close
            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

            if ((tk0h>LastTradingHour) && (UseTimeFilter))  // utols ra utn trail x pips
            {
               RefreshRates();
               t_spread=MarketInfo(oap, MODE_SPREAD);
               sll=Bid-(StopAddPips*Point);
               if ((OrderStopLoss()<Bid-(StopAddPips*Point)) || (OrderStopLoss() == 0))
               {
                  Print ("LTH Trail BUY SL (2): ",oap, " opnr: ",opnr, " SL: ", DoubleToStr(sll,Digits));
                  tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(sll,Digits), OrderTakeProfit(), 0, MediumSeaGreen);
                  if (!tmi1) { errorlog1(sll, OrderTakeProfit(),2); }
               }
            }

            Order = SIGNAL_NONE;
            if ((otp==2) || (otp==1))
            {
               if (t2over==1)
               {
                  // Order = SIGNAL_CLOSEBUY;
                  double p0c=iClose(oap, PERIOD_H1,0);
                  double p0l=p0c-(StopAddPips*Point);
                  if (p0l>OrderStopLoss())
                  {
                     Print ("T2 NTT Trail BUY SL (3): ",oap, " opnr: ",opnr, " SL: ", DoubleToStr(p0l,Digits));
                     tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(p0l,Digits), OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!tmi1) { errorlog1(p0l, OrderTakeProfit(),3); }
                  }
               }
            }

            if (otp==1)
            {
               if (TPShift==1)
               {
                  if ((iTime(oap, PERIOD_H1,0)<OrderOpenTime()) && (OrderOpenTime()<(iTime(oap, PERIOD_H1,0)+3600)))
                  {
                     if (Bid>OrderTakeProfit()-(MinPSRDist*Point))
                     {
                        double nppt=getnextpp(OrderTakeProfit()+(MinPSRDist*Point), 1);
                        if (nppt==0) { nppt=OrderTakeProfit()+(FixedTPTargets[opnr]*Point); }
                        nppt=NormalizeDouble(nppt,Digits);
                        Print ("T2 Trail BUY TARGET (4): ",oap, " opnr: ",opnr, " NPPT: ", DoubleToStr(nppt,Digits));
                        tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), nppt, 0, MediumSeaGreen);
                        if (!tmi1) { errorlog1(OrderStopLoss(), nppt,4); }
                     }
                  }
               }
            }

            if (otp==3)
            {
               if (OrderOpenTime()<iTime(oap, PERIOD_H1,1)) // (t2over==1)  // ? shift mikor?
               {
                  // SL SET: BAR 1 LOW
                  double p1l=iLow(oap, PERIOD_H1,1);
                  p0c=iClose(oap, PERIOD_H1,0);
                  p0l=iLow(oap, PERIOD_H1,0);
                  //if (p1l>p0c) { p1l=p0l; }
                  p0l=p1l-(StopAddPips*Point);
                  if (p0l>OrderStopLoss())
                  {
                     Print ("T3 Trail SL (5): ",oap, " opnr: ",opnr, " SL: ", DoubleToStr(p0l,Digits));
                     tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(p0l,Digits), OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!tmi1) { errorlog1(p0l, OrderTakeProfit(),5); }
                  }
               }
            }
            //Print("closebuy ", oap, " (",OrderSymbol(),"/",OrderMagicNumber(), "): ");
            //comm1=comm1+"BUY ("+oap+") "+DoubleToStr(OrderProfit(),2)+"\n";
            //Print("order: buy ", OrderSymbol()," ", OrderMagicNumber(), " otf: ", otf, " ns0: ", ns0, " ns1: ", ns1);

            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+
            RefreshRates();
            t_spread=MarketInfo(oap, MODE_SPREAD);

            if (Order == SIGNAL_CLOSEBUY)
            {
               if (UseSLnotExit)
               {
                  double ps1=(Bid-(SLExitPips*Point));
                  if(OrderStopLoss() < ps1)
                  {
                     if ((Digits==3) || (Digits==5))
                     {
                        ps1=NormalizeDouble(ps1,Digits-1);
                     }
                     ps1=NormalizeDouble(ps1,Digits);
                     if ((OrderStopLoss()==0) || (OrderStopLoss()<ps1))
                     {
                        tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), ps1, OrderTakeProfit(), 0, MediumSeaGreen);
                        Print ("SL Exit Buy (6): SL: ", DoubleToStr(ps1,Digits), " bid: ", DoubleToStr(Bid,Digits), " point: ", DoubleToStr(Point,Digits));
                        if (!tmi1) { errorlog1(ps1, OrderTakeProfit(),6); }
                     }
                  }
               }
               else
               {
                  OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
                  if (SignalMail) SendMail("[Signal Alert]", "[" + oap + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               }
            }
            // BELockAtPips
            if (BELockAtPips>0)
            {
               if (Bid-OrderOpenPrice() > BELockAtPips*Point)
               {
                  sll=OrderOpenPrice()+(BELockAdd*Point);
                  if ((OrderStopLoss() < sll)  || (OrderStopLoss()==0)) 
                  {
                     Print ("BElock BUY (7): ", DoubleToStr(NormalizeDouble(OrderOpenPrice()-(Point*BELockAdd),Digits),Digits), " bid: ", DoubleToStr(Bid,Digits), " point: ", DoubleToStr(Point,Digits) );
                     tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(sll,Digits), OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!tmi1) { errorlog1(sll, OrderTakeProfit(),7); }
                  }
               }
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {
               if(Bid - OrderOpenPrice() > TrailingStop*Point) {
                  sll=Bid - (TrailingStop*Point);
                  if(OrderStopLoss() < sll) {
                     tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(sll,Digits), OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!tmi1) { errorlog1(sll, OrderTakeProfit(),8); }
                  }
               }
            }
         } 

         if(OrderType() == OP_SELL)
         {
            //Close
            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

            if ((tk0h>LastTradingHour) && (UseTimeFilter)) // utols ra utn trail x pips
            {
               RefreshRates();
               double sll=Ask+(StopAddPips*Point);
               if((OrderStopLoss()>sll) || (OrderStopLoss() == 0))
               {
                  Print ("LTH Trail SELL SL (9): ",oap, " opnr: ",opnr, " SL: ", DoubleToStr(sll,Digits));
                  tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(sll,Digits), OrderTakeProfit(), 0, DarkOrange);
                  if (!tmi1) { errorlog1(sll, 0,9); }
               }
            }
            Order = SIGNAL_NONE;
            if ((otp==2) || (otp==1))
            {
               if (t2over==1)
               {
                  // Order = SIGNAL_CLOSESELL;
                  p0c=iClose(oap, PERIOD_H1,0);
                  p0l=p0c+(StopAddPips*Point);
                  if (p0l<OrderStopLoss())
                  {
                     Print ("T2 NTT Trail SELL SL (10): ",oap, " opnr: ",opnr, " SL: ", DoubleToStr(p0l,Digits));
                     tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(p0l,Digits), OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!tmi1) { errorlog1(p0l, 0,10); }
                  }
               }
            }

            if (otp==1)
            {
               if (TPShift==1)
               {
                  if ((iTime(oap, PERIOD_H1,0)<OrderOpenTime()) && (OrderOpenTime()<(iTime(oap, PERIOD_H1,0)+3600)))
                  {
                     if (Ask<OrderTakeProfit()-(50*Point))
                     {
                        nppt=getnextpp(OrderTakeProfit()-(MinPSRDist*Point), 2);
                        if (nppt==0) { nppt=OrderTakeProfit()-(FixedTPTargets[opnr]*Point); }
                        nppt=NormalizeDouble(nppt,Digits);
                        Print ("T2 Trail BUY Target (11): ",oap, " opnr: ",opnr, " TP: ", DoubleToStr(nppt,Digits));
                        tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), nppt, 0, MediumSeaGreen);
                        if (!tmi1) { errorlog1(OrderStopLoss(), nppt,11); }
                     }
                  }
               }
            }

            if (otp==3)
            {
               if (OrderOpenTime()<iTime(oap, PERIOD_H1,1)) // (t2over==1)  // ? shift mikor?
               {
                  // SL SET: BAR 1 LOW
                  p1l=iHigh(oap, PERIOD_H1,1);
                  p0c=iClose(oap, PERIOD_H1,0);
                  p0l=iHigh(oap, PERIOD_H1,0);
                  //if (p1l<p0c) { p1l=p0l; }
                  p0l=p0l+(StopAddPips*Point);
                  if (p0l<OrderStopLoss())
                  {
                     Print ("T3 Trail SL (12): ",oap, " opnr: ",opnr, " SL: ", DoubleToStr(p0l,Digits));
                     tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(p0l,Digits), OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!tmi1) { errorlog1(p0l, OrderTakeProfit(),12); }
                  }
               }
            }

            //Print("closesell ", oap, " (",OrderSymbol(),"/",OrderMagicNumber(), "): ");
            //comm1=comm1+"SELL ("+oap+") "+DoubleToStr(OrderProfit(),2)+"\n";
            //Print("order: sell ", OrderSymbol()," ", OrderMagicNumber(), " otf: ", otf, " ns0: ", ns0, " ns1: ", ns1);

            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+
            RefreshRates();
            t_spread=MarketInfo(oap, MODE_SPREAD);

            if (Order == SIGNAL_CLOSESELL)
            {
               if (UseSLnotExit)
               {
                  ps1=(Ask + (SLExitPips*Point));
                  if(OrderStopLoss() > ps1)
                  {
                     if ((Digits==3) || (Digits==5))
                     {
                        ps1=NormalizeDouble(ps1,Digits-1);
                     }
                     ps1=NormalizeDouble(ps1,Digits);
                     if ((OrderStopLoss()==0) || (OrderStopLoss()>ps1))
                     {
                        Print ("SL Exit Sell (13): SL: ", DoubleToStr(ps1,Digits), " ask: ", DoubleToStr(Ask,Digits), " point: ", DoubleToStr(Point,Digits) );
                        tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), ps1, OrderTakeProfit(), 0, DarkOrange);
                        if (!tmi1) { errorlog1(ps1, OrderTakeProfit(),13); }
                     }
                  }
               }
               else
               {
                  OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
                  if (SignalMail) SendMail("[Signal Alert]", "[" + oap + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               }
            }
            // BELockAtPips
            if (BELockAtPips>0)
            {
               sll=OrderOpenPrice()-(BELockAdd*Point);
               if (OrderOpenPrice() - Ask > BELockAtPips*Point)
               {
                  if ((OrderStopLoss() > sll) || (OrderStopLoss()==0)) 
                  {
                     Print ("BE Lock SELL (14): ", DoubleToStr(OrderOpenPrice()-(BELockAdd*Point),Digits), " ASK: ", DoubleToStr(Ask,Digits));
                     tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(sll,Digits), OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!tmi1) { errorlog1(sll, OrderTakeProfit(),14); }
                  }
               }
            }

            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {
               if((OrderOpenPrice() - Ask) > (TrailingStop*Point)) {
                  sll=Ask + (TrailingStop*Point);
                  if((OrderStopLoss() > sll) || (OrderStopLoss() == 0)) {
                     tmi1=OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(sll,Digits), OrderTakeProfit(), 0, DarkOrange);
                     if (!tmi1) { errorlog1(sll, OrderTakeProfit(),15); }
                  }
               }
            }
         }
      }
   }

   for (int ti=1;ti<100;ti++)
   {
      trtr[ti][4]=0;
   }

   Total=OrdersTotal();
   for (i = 0; i < Total; i ++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      omnr=OrderMagicNumber();
      //int otf=getordertf(OrderMagicNumber());
      int otf=5;
      oap=OrderSymbol();
      if (oap==Symbol())
      {
         int oapnr=getpairnr(oap);
         int otck=OrderTicket();
         double oprf=OrderProfit()+OrderCommission()+OrderSwap();
         ti=findti2(otck);
         trtr[ti][1]=otck;
         trtr[ti][2]=oapnr;
         trtr[ti][3]=otf;
         trtr[ti][4]=1;
         // min profit
         if ((trtr[ti][5]==0) || (trtr[ti][5]>oprf)) { trtr[ti][5]=oprf; }
         // max profit
         if ((trtr[ti][6]==0) || (trtr[ti][6]<oprf)) { trtr[ti][6]=oprf; trtr[ti][7]=trtr[ti][5]; }
         trtr[ti][8]=oprf;
      }
   }

   trtrlog();

// ----- trade management vge -----

//   comm=comm+"---------------------\n";

   string comm1="";
   double opr=0;
   double tpr=0;
   double ttsl=0;
   double lck=0, tlck=0;

   tickets_t1=0;
   ArrayInitialize(tpo,-1);
   Total = OrdersTotal();
   for (i = 0; i < Total; i ++)
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      omnr=OrderMagicNumber();
      otp=MathMod(omnr,10);
      oap=OrderSymbol();

      //Print(oap, " mn: ", omnr, " time: ", OrderOpenTime());
      if((omnr>MagicNRMin) && (omnr<MagicNRMax) && (oap==Symbol()))
      {
         tickets_t1+=OrderTicket();
         int mgnp=getpairnr(oap);
         tpo[OrderType()+1]=1;
      }

      if((omnr>MagicNRMin) && (omnr<MagicNRMax) && (oap==Symbol()))
      {
         if (OrderType() == OP_BUY)
         {
            double tsl=OrderStopLoss()-OrderOpenPrice();
         }
         if (OrderType() == OP_SELL)
         {
            tsl=OrderOpenPrice()-OrderStopLoss();
         }         
         double tsl2=tsl/Point;
         double tj=0;
         if ((Digits==3) || (Digits==5)) { tj=1; tsl2=tsl2/10; }
         lck=0;
         if (tsl2>0) { lck=tsl2; tlck=tlck+tsl2;}
         opr=OrderProfit()+OrderCommission()+OrderSwap();
         tpr=tpr+opr;
         ttsl=ttsl+tsl2;
         if (OrderType() == OP_BUY)
         {
            comm1=comm1+"BUY ("+otp+"/"+omnr+") "+DoubleToStr(opr,2)+" SL: "+DoubleToStr(tsl2,tj)+" lck: "+DoubleToStr(lck,tj)+"\n";
         }
         if (OrderType() == OP_SELL)
         {
            comm1=comm1+"SELL ("+otp+"/"+omnr+") "+DoubleToStr(opr,2)+" SL: "+DoubleToStr(tsl2,tj)+" lck: "+DoubleToStr(lck,tj)+"\n";
         }
      }
   }

   comm1=comm1+"Orders: "+Total+"\n";
   comm1=comm1+"TOTAL PROFIT: "+DoubleToStr(tpr,2)+"\n";
   comm1=comm1+"PROFIT LOCKED: "+DoubleToStr(tlck,2)+"\n";
   comm1=comm1+"TOTAL SL: "+DoubleToStr(ttsl,2)+"\n";
   //Print(comm1);
   // string ap=Symbol();
   // int tfc=Period();

   if ((tickets_t1!=tickets_t2) || (iTime(Symbol(),OOTD_period,0)!=OOTDbar))
   {
      if (tickets_t1!=tickets_t2) { trtrlog(); opordlog(); }
      tickets_t2=tickets_t1;
      OOTDbar=iTime(Symbol(),OOTD_period,0);
      if (OnlyOneTradeADay) { checkorderhist(Symbol()); }
   }

   bool NoNewTrade=false;
   if (MathAbs(ttsl*10)>MaxTotalOpenSL) { NoNewTrade=true; }
   if (NoNewTrade)
   {
      comm1=comm1+"New Trade: NEM OK \n";
   } else {
      comm1=comm1+"New Trade: OK \n";
   }

   tk0h=StringSubstr(TimeToStr(TimeCurrent(),TIME_MINUTES),0,5);  // MM.DD hh:mm  // ("01.01 00:00") 
   if (UseTimeFilter)
   {
      string fth=FirstTradingHour;
      if (strategy_version==2) { fth=FirstTradingHour_v2; }
      if ((tk0h<fth) || (tk0h>LastTradingHour)) 
      { 
         //Trade_tf=false;
         NoBuyToday=true;
         NoSellToday=true;
         comm2=tk0h+" NO TRADING TIME ("+fth+" - "+LastTradingHour+")\n";
      } else { NoBuyToday=false; NoSellToday=false; }
   }

   if (NoNewTrade) { Trade_tf=false; }

   maxspread=avgspread;
   if (fixedspread) { maxspread=0; }

   //----------------------------------------------------------------

   if (Trade_tf)
   {
      RefreshRates();
      t_spread=MarketInfo(ap, MODE_SPREAD);

      //----------------------------------------------------------------

      for (x=1;x<10;x++)
      {
         if (currentbar2[x] != iTime(ap, TFs[x], 0))
         {
            currentbar2[x] = iTime(ap, TFs[x], 0);
            Calc_SR6(ap, TFs[x], x);
         }
      }

      for (int nt=5;nt<9;nt++)
      {
         if (currentbar3[nt] != iTime(ap, TFs[nt], 0))
         {
            currentbar3[nt] = iTime(ap, TFs[nt], 0);
            TLSwingMap(ap, TFs[nt], nt);

            // ---- price range detecting V2 INSIDE BARS ------------------------
            if (tfc<10080) { ChkRanging(ap, TFs[nt], nt); }
            string rrs="";
            RRcomm[nt]="";
            if (cpr[nt][2]>0)
            {
               RRcomm[nt]=TFns[nt]+" INSIDE BAR ("+DoubleToStr(cpr[nt][1],0)+") L: "+DoubleToStr(cpr[nt][2],Digits)+" H: "+DoubleToStr(cpr[nt][3],Digits)+" DIFF: "+DoubleToStr((cpr[nt][3]-cpr[nt][2])/Point/dgt,dgt2);
               rrs="\n";
            }
            if (tfc<10080) { ChkSidewaysPattern(ap, TFs[nt], nt); }
            if (cps[nt][2]>0)
            {
               RRcomm[nt]=RRcomm[nt]+rrs+TFns[nt]+" SIDEWAYS PATTERN ("+DoubleToStr(cps[nt][1],0)+") L: "+DoubleToStr(cps[nt][2],Digits)+" H: "+DoubleToStr(cps[nt][3],Digits)+" DIFF: "+DoubleToStr((cps[nt][3]-cps[nt][2])/Point/dgt,dgt2);
            }
            // -------------------------------------------------------------------
         }
         TLcomm[nt]="";
         string pdi="";
         if (_TLBU[nt]>0)
         {
            if (Ask>_TLBU[nt]) { pdi=" ABOVE "; } else { pdi=" BELOW "; }
            TLcomm[nt]="Price "+DoubleToStr(((_TLBU[nt]-Ask)/Point)/dgt,dgt2)+" points"+pdi+"upper(R) TL "+TFns[nt]+" ("+DoubleToStr(_TLBU[nt],Digits)+")\n";
         }
         if (_TLBD[nt]>0)
         {
            if (Bid>_TLBU[nt]) { pdi=" ABOVE "; } else { pdi=" BELOW "; }
            TLcomm[nt]=TLcomm[nt]+"Price "+DoubleToStr(((Bid-_TLBD[nt])/Point)/dgt,dgt2)+" points"+pdi+"lower(S) TL "+TFns[nt]+" ("+DoubleToStr(_TLBD[nt],Digits)+")\n";
         }
      }

      if (currentbar != iTime(ap, PERIOD_H1, 0))
      {
         currentbar = iTime(ap, PERIOD_H1, 0);
         initlog=3;

         int s1sh=FindNextSwing(ap, PERIOD_H1, Ask, 2, 0);
         int s1sl=FindNextSwing(ap, PERIOD_H1, Bid, 1, 0);
         double s1shp=iHigh(ap,PERIOD_H1,s1sh);
         double s1slp=iLow(ap,PERIOD_H1,s1sl);
         if (s1sh>0) { comm_sw="Nearest H1 Swing High ("+s1sh+") @ "+DoubleToStr(s1shp,Digits)+" / "+DoubleToStr((s1shp-Ask)/Point/dgt,dgt2)+"\n"; }
         if (s1sl>0) { comm_sw=comm_sw+"Nearest H1 Swing Low ("+s1sl+") @ "+DoubleToStr(s1slp,Digits)+" / "+DoubleToStr((Bid-s1slp)/Point/dgt,dgt2)+"\n"; }

         // --- b0sh ---
         int b0sh=-1, b1sh=-1, b2sh=-1;

         string tk1h;

         tk0h=StringSubstr(TimeToStr(TimeCurrent(),TIME_MINUTES),0,5);  // MM.DD hh:mm  // ("01.01 00:00") 

         for (int jt=0; jt < 24; jt++)
         {
            tk1h=StringSubstr(TimeToStr(iTime(Symbol(),PERIOD_H1,jt),TIME_MINUTES),0,5);
            if (tk1h==RangeFirstBarTime_v2)
            { 
               b2sh=jt;
               jt=25;
            }
            if (tk1h==RangeFirstBarTime)
            { 
               b0sh=jt; // first bar shift
               b1sh=jt-range_length+1;
               //if (b1sh<0) { b1sh=0; }
            }
         }   

         H1R_E=0; H1R_S=0; H1S_E=0; H1S_S=0;

         Print(ap, " B0SH: ", b0sh, " B1SH: ",b1sh, " B2SH: ",b2sh);

         int ph=0; int pl=0;
         int p1=0; int p1x=0;
         int p2=0; int p2x=0;
         bool megvan=false;
         int sfit=0;
         while (!megvan)
         {
            sfit++;
            if (pl<b2sh+1)
            {
               pl=FindNextSwing(ap, PERIOD_H1, 100000, 1, pl);
               if ((pl>=b1sh) && (pl<=b0sh)) { p1=pl; }
               if ((pl>b0sh)  && (pl<=b2sh)) { p1x=pl; }
            }
            if (ph<b2sh+1)
            {
               ph=FindNextSwing(ap, PERIOD_H1, 0, 2, ph);
               if ((ph>=b1sh) && (ph<=b0sh)) { p2=ph; }
               if ((ph>b0sh)  && (ph<=b2sh)) { p2x=ph; }
            }
            if ((ph>b2sh+1) && (pl>b2sh+1)) { megvan=true; }
            if (sfit>50) { megvan=true; }
         }

         if (strategy_version==1) { p1x=0; p2x=0; }
         
         Print("SWINGS LOW: P1: ",p1, " P1X: ",p1x);
         Print("SWINGS HIGH: P2: ",p2, " P2X: ",p2x);
         datetime dt;

         ObjectDelete("WR-Start");
         ObjectDelete("WR-Start-2");
         ObjectDelete("WR-End");

         if (strategy_version==2)
         {
            if (b2sh>=0)
            {
               dt=iTime(ap, PERIOD_H1, b2sh);
               ObjectCreate ("WR-Start-2", OBJ_VLINE, 0, dt, 0);
               ObjectSet("WR-Start-2", OBJPROP_STYLE, STYLE_DOT);
               ObjectSet("WR-Start-2", OBJPROP_COLOR,range_start_ext);
            }
         }
         if (b0sh>=0)
         {
            dt=iTime(ap, PERIOD_H1, b0sh);
            ObjectCreate ("WR-Start", OBJ_VLINE, 0, dt, 0);
            ObjectSet("WR-Start", OBJPROP_STYLE, STYLE_DOT);
            ObjectSet("WR-Start", OBJPROP_COLOR,range_start);
         }
         if (b1sh>=0)
         {
            dt=iTime(ap, PERIOD_H1, b1sh);
            ObjectCreate ("WR-End", OBJ_VLINE, 0, dt, 0);
            ObjectSet("WR-End", OBJPROP_STYLE, STYLE_DOT);
            ObjectSet("WR-End", OBJPROP_COLOR,range_end);
         }

         // --- b0sh ---

         if (strategy_version==1)
         {
            Draw_H1_Trends(p2, p1);
         }
         if (strategy_version==2)
         {
            if (p2x>0)
            {
               if (ChkPRMADir(ap, PERIOD_H1, p2x)==1) { p2=p2x; H1_R_ = Yellow; }
            }
            if (p1x>0)
            {
               if (ChkPRMADir(ap, PERIOD_H1, p1x)==2) { p1=p1x; H1_S_ = Yellow; }
            }
            Draw_H1_Trends(p2, p1);
         }

         string currentbar_hhmm=StringSubstr(TimeToStr(currentbar),0,5);
         if ((PivotStartingHour>=currentbar_hhmm) || (PPs[1][1]==0)) { npivp(ap); }

         h1=H1R_E; h2=H1R_S; l1=H1S_E; l2=H1S_S;
         hh1=0; hh2=0; ll1=0; ll2=0; TLBU=0; TLBD=0; TLUM=0; TLLM=0;
         if (h1>0)
         {
            hh1=iHigh(ap, PERIOD_H1, h1); hh2=iHigh(ap, PERIOD_H1, h2);
            TLBU=hh2-(hh2-hh1)/(h2-h1)*h2;
            TLUM=(hh2-hh1)/(h2-h1);
         }
         if (l1>0)
         {
            ll1=iLow(ap, PERIOD_H1, l1); ll2=iLow(ap, PERIOD_H1, l2);
            TLBD=ll2+(ll1-ll2)/(l2-l1)*l2;
            TLLM=(ll1-ll2)/(l2-l1);
         }

         double utl_brk_price=0;
         double ltl_brk_price=0;
         bool utl_brk=false;
         bool ltl_brk=false;

         if (h1>0)
         {
            for (i=0;i<=h1;i++)
            {
               double tbui=hh1-(TLUM*(h1-i));
               ipr=iHigh(ap, PERIOD_H1, i);
               if (ipr>tbui+(TLBreakoutMinPips*Point)) { utl_brk=true; utl_brk_price=tbui; }
               //Print(ap, " Hi: ", i, " TLBU(i): ", DoubleToStr(tbui,Digits), " IPR: ", DoubleToStr(ipr,Digits), " BREAK: ", utl_brk);
            }
            if ((utl_brk) && (ChangeBrokenTLColor))
            {
               ObjectSet("H1_R_", OBJPROP_STYLE, STYLE_DASH);
               //ObjectSet("H1_R_", OBJPROP_WIDTH, 1);
               ObjectSet("H1_R_", OBJPROP_COLOR, BrokenUPTL);
               WindowRedraw();
            }
            if ((utl_brk) && (!TradeBrokenTLs)) { NoBuyToday=true; }
         }

         if (l1>0)
         {
            for (i=0;i<=l1;i++)
            {
               double tbdi=ll1+(TLLM*(l1-i));
               ipr=iLow(ap, PERIOD_H1, i);
               if (ipr<tbdi-(TLBreakoutMinPips*Point)) { ltl_brk=true; ltl_brk_price=tbdi; }
               //Print(ap, " Li: ", i, " TLBD(i): ", DoubleToStr(tbdi,Digits), " IPR: ", DoubleToStr(ipr,Digits), " BREAK: ", ltl_brk);
            }
            if ((ltl_brk) && (ChangeBrokenTLColor))
            {
               //Print(ap, " Lower TL Broken: ");
               ObjectSet("H1_S_", OBJPROP_STYLE, STYLE_DASH);
               //ObjectSet("H1_S_", OBJPROP_WIDTH, 1);
               ObjectSet("H1_S_", OBJPROP_COLOR, BrokenDNTL);
               WindowRedraw();
            }
            if ((ltl_brk) && (!TradeBrokenTLs)) { NoSellToday=true; }
         }

         Print(ap, " H1: ", h1, " H2: ", h2, " L1: ", l1, " L2: ", l2);
         Print(ap, " HH1: ", hh1, " HH2: ", hh2, " LL1: ", ll1, " LL2: ", ll2);
         Print(ap, " TLBU: ",DoubleToStr(TLBU,Digits)," | TLBD: ",DoubleToStr(TLBD,Digits));
         Print(ap, " TLUM: ",DoubleToStr(TLUM/Point/dgt,dgt2)," | TLLM: ",DoubleToStr(TLLM/Point/dgt,dgt2));
         Print(ap, " UPPER BREAK: ", utl_brk," | LOWER BREAK: ",ltl_brk);

         comm3="\n";
         comm3=comm3+"Upper TL: "+DoubleToStr(TLBU,Digits)+" | slope: "+DoubleToStr(TLUM/Point/dgt,Digits)+" p/bar";
         if (utl_brk) { comm3=comm3+" (BROKEN @ "+DoubleToStr((Ask-utl_brk_price)/Point/dgt,dgt2)+" / "+DoubleToStr(utl_brk_price,Digits)+")"; }

         comm3=comm3+"\n";
         comm3=comm3+"Lower TL: "+DoubleToStr(TLBD,Digits)+" | slope: "+DoubleToStr(TLLM/Point/dgt,Digits)+" p/bar";
         if (ltl_brk) { comm3=comm3+" (BROKEN @ "+DoubleToStr((ltl_brk_price-Bid)/Point/dgt,dgt2)+" / "+DoubleToStr(ltl_brk_price,Digits)+")"; }
         comm3=comm3+"\n";

         // ---- price range detecting ----------------------------------
         PRH = iHigh(ap, PERIOD_H1, iHighest(ap, PERIOD_H1, MODE_HIGH, 4, 0));
         PRL = iLow(ap, PERIOD_H1, iLowest(ap, PERIOD_H1, MODE_LOW, 4, 0));
         double b4d=(MathAbs(PRH-PRL)/Point)/dgt;
         b4r="";
         b4r="\nLast 4 bar range: H: "+DoubleToStr(PRH,Digits)+" L: "+DoubleToStr(PRL,Digits)+" DIFF: "+DoubleToStr(b4d,dgt2)+"\n";

         //----------------------------------------------------------------

      }  // if currentbar

      //----------------------------------------------------------------
      double pnow, pstoph, pstopl, nop, ncl, pcl, phg, nlow, nhigh, plow, pop;

      filterinfo(Symbol());

      Order=SIGNAL_NONE;

      h1=H1R_E; h2=H1R_S; l1=H1S_E; l2=H1S_S;
      hh1=0; hh2=0; ll1=0; ll2=0; TLBU=0; TLBD=0;
      if (h1>0)
      {
         hh1=iHigh(ap, PERIOD_H1, h1); hh2=iHigh(ap, PERIOD_H1, h2);
         TLBU=hh2-(hh2-hh1)/(h2-h1)*h2;
         double pTLBU=hh2-(hh2-hh1)/((h2-1)-(h1-1))*(h2-1);
         //Print(ap, " TLBU: ", DoubleToStr(TLBU,Digits), " pTLBU: ", DoubleToStr(pTLBU,Digits));
      }
      if (l1>0)
      {
         ll1=iLow(ap, PERIOD_H1, l1); ll2=iLow(ap, PERIOD_H1, l2);
         TLBD=ll2+(ll1-ll2)/(l2-l1)*l2;
         double pTLBD=ll2+(ll1-ll2)/((l2-1)-(l1-1))*(l2-1);
         //Print(ap, " TLBD: ", DoubleToStr(TLBD,Digits), " pTLBD: ", DoubleToStr(pTLBD,Digits));
      }

      double BrkUP=NormalizeDouble(TLBU,Digits);
      double BrkDN=NormalizeDouble(TLBD,Digits);
      
      //double nppu=getnextpp(BrkUP, 1);
      //double nppd=getnextpp(BrkDN, 2);

      double NewBrkUP=BrkUP;
      double NewBrkDN=BrkDN;

      double nb1=0;

      //if (h1>0) Print(ap, " BrkUP ",DoubleToStr(BrkUP,Digits), " MOD MAX: ", DoubleToStr(BrkUP+(MaxPSRDist*Point),Digits));
      //if (l1>0) Print(ap, " BrkDN ",DoubleToStr(BrkDN,Digits), " MOD MIN: ", DoubleToStr(BrkDN-(MaxPSRDist*Point),Digits));

      comm_bu="";
      comm_bd="";
      int ppnc=0;
      
      for (int tt=1;tt<14;tt++)
      {
         for (int tt2=1;tt2<4;tt2++)
         {
            //Print(ap, " t1: ", tt, " t2: ", tt2, " PP: ", PPTFn[tt2]+PPn[tt]," ", DoubleToStr(PPs[tt][tt2],Digits));
            nb1=PPs[tt][tt2];
            if ((nb1>0) && (nb1<BrkUP+(MaxPSRDist*Point)) && (nb1>BrkUP))
            { 
               if (nb1>NewBrkUP) { NewBrkUP=nb1; }
               //Print(ap, " BrkUP MOD PIVOT: TLBU: ", DoubleToStr(BrkUP,Digits), " -> ", DoubleToStr(NewBrkUP,Digits));
               comm_bu=comm_bu+"PIVOT "+PPTFn[tt2]+PPn[tt]+": "+DoubleToStr(PPs[tt][tt2],Digits)+"\n";
            }
            if ((nb1>0) && (nb1>BrkDN-(MaxPSRDist*Point)) && (nb1<BrkDN))
            {
               if (nb1<NewBrkDN) { NewBrkDN=nb1; }
               //Print(ap, " BrkDN MOD PIVOT: TLBU: ", DoubleToStr(BrkDN,Digits), " -> ", DoubleToStr(NewBrkDN,Digits));
               comm_bd=comm_bd+"PIVOT "+PPTFn[tt2]+PPn[tt]+": "+DoubleToStr(PPs[tt][tt2],Digits)+"\n";
            }
         }
      }

      for (x=5;x<8;x++)
      {
         nb1=SR6R[x];
         if ((nb1>0) && (nb1<BrkUP+(MaxPSRDist*Point)) && (nb1>BrkUP))
         { 
            if (nb1>NewBrkUP) { NewBrkUP=nb1; }
            //Print(ap, " BrkUP MOD SR6R: ", DoubleToStr(BrkUP,Digits), " -> ", DoubleToStr(NewBrkUP,Digits));
            //comm_bu=comm_bu+"SR6 Res. "+TFns[x]+": "+DoubleToStr(SR6R[x],Digits)+"\n";
         }
         nb1=_TLBU[x];
         if ((nb1>0) && (nb1<BrkUP+(MaxPSRDist*Point)) && (nb1>BrkUP))
         {
            if (nb1>NewBrkUP) { NewBrkUP=nb1; }
            //Print(ap, " BrkUP MOD Upper TL: ", DoubleToStr(BrkUP,Digits), " -> ", DoubleToStr(NewBrkUP,Digits));
            comm_bu=comm_bu+"Upper TL "+TFns[x]+": "+DoubleToStr(_TLBU[x],Digits)+"\n";
         }

         nb1=SR6S[x];
         if ((nb1>0) && (nb1>BrkDN-(MaxPSRDist*Point)) && (nb1<BrkDN)) 
         {
            if (nb1<NewBrkDN) { NewBrkDN=nb1; }
            //Print(ap, " BrkDN MOD SR6S: ", DoubleToStr(BrkDN,Digits), " -> ", DoubleToStr(NewBrkDN,Digits));
            //comm_bd=comm_bd+"SR6 Supp. "+TFns[x]+": "+DoubleToStr(SR6S[x],Digits)+"\n";
         }
         nb1=_TLBD[x];
         if ((nb1>0) && (nb1>BrkDN-(MaxPSRDist*Point)) && (nb1<BrkDN))
         {
            if (nb1<NewBrkDN) { NewBrkDN=nb1; }
            //Print(ap, " BrkDN MOD TLBD: ", DoubleToStr(BrkDN,Digits), " -> ", DoubleToStr(NewBrkDN,Digits));
            comm_bd=comm_bd+"Lower TL "+TFns[x]+": "+DoubleToStr(_TLBD[x],Digits)+"\n";
         }
      }

      //comm2=comm2+" | MOD TLBU: "+DoubleToStr(BrkUP,Digits)+" | TLBD: "+DoubleToStr(BrkDN,Digits);

      if (NewBrkUP!=BrkUP)
      {
         comm_bu="OBJECTS NEAR UPPER TL "+DoubleToStr(BrkUP,Digits)+" - "+DoubleToStr(BrkUP+(MaxPSRDist*Point),Digits)+": \n"+comm_bu+"\n";
      }
      if (NewBrkDN!=BrkDN)
      {
         comm_bd="OBJECTS NEAR LOWER TL "+DoubleToStr(BrkDN,Digits)+" - "+DoubleToStr(BrkDN-(MaxPSRDist*Point),Digits)+": \n"+comm_bd+"\n";
      }

      if (NewBrkUP>BrkUP) { BrkUP=NewBrkUP; }
      if ((NewBrkDN<BrkDN) && (NewBrkDN>0)) { BrkDN=NewBrkDN; }

      comm2=comm2+"\n"+comm_tech_history;
      comm2=comm2+comm_tech_tls;
      comm2=comm2+comm_bu+comm_bd+comm2+"\n";
      //comm2=comm2+"\n";
      
      if (OnlyOneTradeADay)
      {
         if (NoBuyToday) { comm2=comm2+"NO BUY ORDERS \n"; } else { comm2=comm2+"BUY ORDERS OK \n"; } 
         if (NoSellToday) { comm2=comm2+"NO SELL ORDERS \n"; } else { comm2=comm2+"SELL ORDERS OK \n"; } 
      }

      if (PivotBrokerTime) { comm2=comm2+"Pivot Time: Broker timezone\n"; }
      else { comm2=comm2+"Pivot Time: "+PivotStartingHour+"\n"; }

      for (x=5;x<9;x++)
      {
         double srd=(SR6R[x]-SR6S[x])/Point;
         //comm2=comm2+"SR6 "+TFns[x]+" S: "+DoubleToStr(SR6S[x],Digits)+" | R: "+DoubleToStr(SR6R[x],Digits)+" DIFF: "+DoubleToStr(srd/dgt,dgt2);
         //comm2=comm2+"\n";
      }

      double t_tickv=MarketInfo(ap, MODE_TICKVALUE);

      // ------------------ SL, TARGET, BUY, SELL ------------------

      buytgt=0;
      buysl=0;

      if (h1>0)
      {
         // TARGET: Next Pivot SR
         buytgt=getnextpp(MathMax(Ask,BrkUP)+((TLBreakoutMinPips+MinPSRDist)*Point), 1);
         buytgt=buytgt-(TPSubsPips*Point);
         if (UseFixedTarget) { buytgt=MathMax(Ask,BrkUP)+(FixedTPTargets[apnr]*Point); }
         //Print(ap, " BUY TARGET 1: ", DoubleToStr(buytgt,Digits));
         //------------------------------------------
         // STOP: nearest swing low: s1slp
         pstopl=iLow(ap, PERIOD_H1, 0);
         double pstopl2 = iLow(ap, PERIOD_H1, iLowest(ap, PERIOD_H1, MODE_LOW, 1, 0));
         double nsl1=getnextpp(BrkUP-(MinSL*Point), 2);
         pstopl=MathMin(pstopl, nsl1);
         buysl=pstopl-(StopAddPips*Point);
         double tsl_diff=(Ask-pstopl)/Point;
         double bmaxsl=Ask-(MaxSLPerTrade*Point);

         buysl=MathMin(pstopl, pstopl2);
         buysl=pstopl-(StopAddPips*Point);
         double SL=buysl;
         //double tsl_diff2=tsl_diff*t_tickv;
         double tsl_diff2=tsl_diff;

         if (tsl_diff2<MaxSLPerTrade)
         {
            //Print("BUY SLD OK: ", ap, "/",tfc,": ask: ", DoubleToStr(Ask,Digits) , " SL: ", DoubleToStr(SL,Digits)," diff: ", tsl_diff, " diff2: ", DoubleToStr(tsl_diff2,Digits));
         }
         else
         {
            // Print("BUY SLD NEM OK: ", ap, "/",tfc,": ask: ", DoubleToStr(Ask,Digits) , " SL: ", DoubleToStr(SL,Digits)," diff: ", tsl_diff, " diff2: ", DoubleToStr(tsl_diff2,Digits));
            NoNewTrade=true;
            Order=0;
         }
      }

      selltgt=0;
      sellsl=0;

      if (l1>0)
      {
         // TARGET: Next Pivot SR
         selltgt=getnextpp(MathMin(Bid,BrkDN)-((TLBreakoutMinPips+MinPSRDist)*Point), 2);
         selltgt=selltgt+(TPSubsPips*Point);
         if (UseFixedTarget) { selltgt=MathMax(Bid,BrkDN)-(FixedTPTargets[apnr]*Point); }
         //Print(ap, " SELL TARGET 1: ", DoubleToStr(selltgt,Digits));
         //------------------------------------------
         // STOP: nearest swing high: s1shp
         pstoph=iHigh(ap, PERIOD_H1, 0);
         double pstoph2 = iHigh(ap, PERIOD_H1, iHighest(ap, PERIOD_H1, MODE_HIGH, 1, 0));
         nsl1=getnextpp(BrkDN+(MinSL*Point), 2);
         pstopl=MathMax(pstoph, nsl1);
         sellsl=pstoph+(StopAddPips*Point);
         tsl_diff=(pstopl-Bid)/Point;
         double smaxsl=Bid+(MaxSLPerTrade*Point);
         sellsl=MathMax(pstoph, pstoph2);
         sellsl=pstoph+(StopAddPips*Point);
         SL=sellsl;
         //double tsl_diff2=tsl_diff*t_tickv;
         tsl_diff2=tsl_diff;

         if (tsl_diff2<MaxSLPerTrade)
         {
            //Print("SELL SLD OK: ", ap, "/",tfc,": bid: ", DoubleToStr(Bid,Digits) , " SL: ", DoubleToStr(SL,Digits)," diff: ", tsl_diff, " diff2: ", DoubleToStr(tsl_diff2,Digits));
         }
         else
         {
            // Print("SELL SLD NEM OK: ", ap, "/",tfc,": bid: ", DoubleToStr(Bid,Digits) , " SL: ", DoubleToStr(SL,Digits)," diff: ", tsl_diff, " diff2: ", DoubleToStr(tsl_diff2,Digits));
            NoNewTrade=true;
            Order=0;
         }
      }
      // -----------------------------------------------------------

      comm2=comm2+b4r;
      comm2=comm2+"\n";
      comm2=comm2+"Break UP: "+DoubleToStr(BrkUP,Digits)+" | Break Down: "+DoubleToStr(BrkDN,Digits);
      comm2=comm2+"\n";
      comm2=comm2+comm3;
      comm2=comm2+"\n";
      comm2=comm2+"BUY TARGET: "+DoubleToStr(buytgt,Digits)+" | STOP : "+DoubleToStr(buysl,Digits)+"\n";
      comm2=comm2+"BUY TARGET: "+DoubleToStr(MathAbs(Ask-buytgt)/Point/dgt,dgt2)+" | STOP : "+DoubleToStr(MathAbs(Ask-buysl)/Point/dgt,dgt2)+"\n";
      comm2=comm2+"SELL TARGET: "+DoubleToStr(selltgt,Digits)+" | STOP: "+DoubleToStr(sellsl,Digits)+"\n";
      comm2=comm2+"SELL TARGET: "+DoubleToStr(MathAbs(Bid-selltgt)/Point/dgt,dgt2)+" | STOP : "+DoubleToStr(MathAbs(Bid-sellsl)/Point/dgt,dgt2)+"\n";
      comm2=comm2+"\n"+comm_sw+"\n";
      if (RRcomm[5]!="") { comm2=comm2+RRcomm[5]+"\n"; }
      if (RRcomm[6]!="") { comm2=comm2+RRcomm[6]+"\n"; }
      if (RRcomm[7]!="") { comm2=comm2+RRcomm[7]+"\n"; }
      comm2=comm2+"\n";
      comm2=comm2+"FILTERS:\n";
      comm2=comm2+"\n";

      for(int n=1;n<8;n++)
      {
         comm2=comm2+MTFi[n];
      }
      comm2=comm2+"------------------------------------\n";
      //comm2=comm2+"\n";

      // --- BUY: ---------------------------------------------------------------------------------

      // -----------------------------------------------------------
         if (TradeType4)
         {
            // MODIFY PENDING ORDERS
            Total = OrdersTotal();
            for (i = 0; i<Total; i++)
            {
               OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
               omnr=OrderMagicNumber();
               if ((OrderSymbol()==Symbol()) && (omnr==mmnr4))
               {
                  if (OrderType()==OP_BUYSTOP)
                  {
                     Print ("MOD BUYSTOP (94): OrderPrice: ", OrderOpenPrice(), " BrkUP: ", DoubleToStr(BrkUP,Digits), " ask: ", DoubleToStr(Ask,Digits), " bid: ", DoubleToStr(Bid,Digits), " SL: ", DoubleToStr(buysl,Digits), " TP: ", DoubleToStr(buytgt,Digits) );
                     tmi1=OrderModify(OrderTicket(), NormalizeDouble(BrkUP,Digits), NormalizeDouble(buysl,Digits), NormalizeDouble(buytgt,Digits), 0, DodgerBlue);
                     if (!tmi1) { errorlog1(StopLossLevel, TakeProfitLevel, 94); }
                  }
                  if (OrderType()==OP_SELLSTOP)
                  {
                     Print ("MOD SELLSTOP (95): OrderPrice: ", OrderOpenPrice(), " BrkDN: ", DoubleToStr(BrkDN,Digits), " ask: ", DoubleToStr(Ask,Digits), " bid: ", DoubleToStr(Bid,Digits), " SL: ", DoubleToStr(sellsl,Digits), " TP: ", DoubleToStr(selltgt,Digits) );
                     tmi1=OrderModify(OrderTicket(), NormalizeDouble(BrkDN,Digits), NormalizeDouble(sellsl,Digits), NormalizeDouble(selltgt,Digits), 0, DeepPink);
                     if (!tmi1) { errorlog1(StopLossLevel, TakeProfitLevel, 95); }
                  }
               }
            }
         }

      // -----------------------------------------------------------

      RefreshRates();
      t_spread=MarketInfo(ap, MODE_SPREAD);
      pnow=Ask;
      int stp=0;

      if ((h1>0) && (tpo[5]==-1) && (!NoBuyToday))
      {
         if (TradeType4)
         {
            elog=comm2+"\n";
            elog=elog+TLcomm[5]+TLcomm[6]+TLcomm[7]+TLcomm[8];
            elog=elog+"---------------------\n"+comm1;

               MagicNumber=makemagicnr(apnr, 4);
               if (!checkopenorder(ap, 5, MagicNumber))
               {
                  bspr=NormalizeDouble(BrkUP+(TLBreakoutMinPips*Point),Digits);
                  if (Ask<bspr)
                  {
                     mcom="BUY STOP/"+DoubleToStr(MagicNumber,0);
                     SLLevel=NormalizeDouble(buysl,Digits);
                     TPLevel=NormalizeDouble(buytgt,Digits);
                     otc=OpenOrder(OP_BUYSTOP, mcom, MagicNumber, SLLevel, TPLevel, bspr);
                     if (otc>0)
                     {
                        Print ("open BUY STOP ", ap, " price: ", bspr, " ticket: ",otc," comm: ", mcom, " MN: ",MagicNumber," SL: ",SLLevel, " TP: ",TPLevel);
                        opordlog();
                     }
                  }
               } else { Print("Error: Order already opened!"); }

         }
      }

      if ((h1>0) && (tpo[1]==-1) && (!NoBuyToday))
      {
         // Print(ap, " H1 chk: pnow: ", DoubleToStr(pnow,Digits), " LIM: ", DoubleToStr(TLBU+(TLBreakoutMinPips*Point),Digits), " Dist: ", DoubleToStr((pnow-TLBU+(TLBreakoutMinPips*Point)),Digits));
         nop=iOpen(ap, PERIOD_H1, 0);
         nlow=iLow(ap, PERIOD_H1, 0);
         ncl=iClose(ap, PERIOD_H1, 0);
         bool oke=false;
         if ((nlow<BrkUP) && (nop<BrkUP) && (Ask>BrkUP))
         {
            oke=true;
         }

         if (!oke)
         {
            pTLBU=hh2-(hh2-hh1)/(h2-h1)*(h2-1);
            nop=iOpen(ap, PERIOD_H1, 0);
            pcl=iClose(ap, PERIOD_H1, 1);
            phg=iHigh(ap, PERIOD_H1, 1);
            plow=iLow(ap, PERIOD_H1, 1);
            pop=iOpen(ap, PERIOD_H1, 1);
            if ((pcl<BrkUP) && (pcl>pop) && (nop>BrkUP) && (Ask>BrkUP))
            {
               oke=true;
            }
            if ((pcl>BrkUP) && (pcl>pop) && (plow<BrkUP) && (nop>BrkUP) && (Ask>BrkUP))
            {
               oke=true;
            }
         }

         for(int ni=1;ni<8;ni++)
         {
            if (MTFCheck[ni]) { if (MTFs[ni]!=1) { oke=false; ni=8; } }
         }

         //if (ChkPPMADir(ap, PERIOD_M5, 1)!=1) { oke=false; }
         //if (oke) { if (ChkPPMADir(ap, PERIOD_M5, 0)!=1) { oke=false; } }

         if ((Ask>BrkUP) && (Ask<BrkUP+(TLBreakoutMaxPips*Point)) && oke)
         {
            if (UseSetup1)
            {
               datetime stt=iTime(ap, PERIOD_H1,0);
               double shp=0;
               int shs=0; 
               for (int keres=2;keres<26;keres++)
               {
                  if (iTime(ap, PERIOD_M5, keres)>stt)
                  {
                     double ph0=iHigh(ap, PERIOD_M5, keres-1);
                     double ph1=iHigh(ap, PERIOD_M5, keres);
                     double ph2=iHigh(ap, PERIOD_M5, keres+1);
                     if ((ph1>ph0) && (ph1>ph2) && (ph1>BrkUP)) { if (ph1>shp) { shp=ph1; shs=keres; } }
                  }
               }
               if (shs>0) { comm2=comm2+"SHP: "+DoubleToStr(shp,Digits)+"\n"; }
               if ((Ask>(shp+(dgt*Point))) && (shs>0))
               {
                  Order = SIGNAL_BUY;
                  stp=1;
               }
            }

            if (UseSetup2)
            {
               double po0=iOpen(ap, PERIOD_M5, 0);
               double pc0=iClose(ap, PERIOD_M5, 0);
               double po1=iOpen(ap, PERIOD_M5, 1);
               double pc1=iClose(ap, PERIOD_M5, 1);
               double po2=iOpen(ap, PERIOD_M5, 2);
               double pc2=iClose(ap, PERIOD_M5, 2);
               if ((pc2>BrkUP) && (pc2>po2) && (pc1>po1) && (pc1>pc2) && (pc0>po0) && (po1>BrkUP) && (po2>BrkUP))
               {
                  Order = SIGNAL_BUY;
                  stp=2;
               }
               if ((po1>BrkUP) && (pc1>BrkUP) && (po2>BrkUP) && (pc2>BrkUP) && (pc0>BrkUP) && (po0>BrkUP))
               {
                  Order = SIGNAL_BUY;
                  stp=2;
               }
            }

            if (UseSetup3)
            {
               // SETUP 3: Price above TL
               if ((Ask>BrkUP+(TLBreakoutMinPips*Point)) && (Ask<BrkUP+(TLBreakoutMaxPips*Point)))
               {
                  Order = SIGNAL_BUY;
                  stp=3;
               }
            }

            if (TradeOnlyPivotDir)
            {
               // buy only when price is above PP
               if (Ask<PPs[7][1]) { Order=SIGNAL_NONE; stp=0; }
            }

         }
      }

      if (Order==SIGNAL_BUY)
      {
         elog=comm2+"\n";
         elog=elog+TLcomm[5]+TLcomm[6]+TLcomm[7]+TLcomm[8];
         elog=elog+"---------------------\n"+comm1;

         if ((stp==1) || (stp==2) || (stp==3))
         {
            Print("BUY ",stp," SIG ", ap, " TLBU: ", DoubleToStr(BrkUP,Digits), " shp: ", DoubleToStr(shp,Digits), " SL: ", DoubleToStr(buysl,Digits) ," TP: ", DoubleToStr(buytgt,Digits));
         }

         RefreshRates();
         t_spread=MarketInfo(ap, MODE_SPREAD);
         if ((t_spread>maxspread) && (!fixedspread))
         {
            Print("SPREAD TOO HIGH: ", ap, "/",tfc,": spread: ", DoubleToStr(t_spread,0));
            NoNewTrade=true;
            Order=0;
         }

         if (TradeType1) 
         {
            MagicNumber=makemagicnr(apnr, 1);
            if (!checkopenorder(ap, 1, MagicNumber))
            {
               mcom="BUY T1("+stp+") "+DoubleToStr(MagicNumber,0);
               SLLevel=NormalizeDouble(buysl,Digits);
               TPLevel=NormalizeDouble(buytgt,Digits);
               otc=OpenOrder(OP_BUY, mcom, MagicNumber, SLLevel, TPLevel, 0);
               if (otc>0)
               {
                  Print ("open BUY 1 ", ap, " ticket: ",otc," comm: ", mcom, " MN: ",MagicNumber," SL: ",SLLevel, " TP: ",TPLevel);
                  opordlog();
               }
            } else { Print("Error: Order already opened!"); }
         }
         if (TradeType2)
         {
            MagicNumber=makemagicnr(apnr, 2);
            if (!checkopenorder(ap, 1, MagicNumber))
            {
               mcom="BUY T2("+stp+") "+DoubleToStr(MagicNumber,0);
               SLLevel=NormalizeDouble(buysl,Digits);
               TPLevel=NormalizeDouble(0,Digits);
               otc=OpenOrder(OP_BUY, mcom, MagicNumber, SLLevel, TPLevel, 0);
               if (otc>0)
               {
                  Print ("open BUY 2 ", ap, " ticket: ",otc, " comm: ", mcom, " MN: ",MagicNumber," SL: ",SLLevel, " TP: ",TPLevel);
                  opordlog();
               }
            } else { Print("Error: Order already opened!"); }
         }
         if (TradeType3)
         {
            MagicNumber=makemagicnr(apnr, 3);
            if (!checkopenorder(ap, 1, MagicNumber))
            {
               mcom="BUY T3("+stp+") "+DoubleToStr(MagicNumber,0);
               SLLevel=NormalizeDouble(buysl,Digits);
               TPLevel=NormalizeDouble(0,Digits);
               otc=OpenOrder(OP_BUY, mcom, MagicNumber, SLLevel, TPLevel, 0);
               if (otc>0)
               {
                  Print ("open BUY 3 ", ap, " ticket: ",otc, " comm: ", mcom, " MN: ",MagicNumber," SL: ",SLLevel, " TP: ",TPLevel);
                  opordlog();
               }
            } else { Print("Error: Order already opened!"); }
         }
      }

      // --- BUY ---------------------------------------------------------------------------------

      //--------------------------------------------------------------------------------------------

      // --- SELL: --------------------------------------------------------------------------------

      pnow=Bid;

      if ((l1>0) && (tpo[6]==-1) && (!NoSellToday))
      {
         if (TradeType4)
         {
            elog=comm2+"\n";
            elog=elog+TLcomm[5]+TLcomm[6]+TLcomm[7]+TLcomm[8];
            elog=elog+"---------------------\n"+comm1;

               MagicNumber=makemagicnr(apnr, 4);
               if (!checkopenorder(ap, 6, MagicNumber))
               {
                  bspr=NormalizeDouble(BrkDN-(TLBreakoutMinPips*Point),Digits);
                  if (Bid>bspr)
                  {
                     mcom="SELL STOP/"+DoubleToStr(MagicNumber,0);
                     SLLevel=NormalizeDouble(sellsl,Digits);
                     TPLevel=NormalizeDouble(selltgt,Digits);
                     otc=OpenOrder(OP_SELLSTOP, mcom, MagicNumber, SLLevel, TPLevel, bspr);
                     if (otc>0)
                     {
                        Print ("open SELL STOP ", ap, " price: ", bspr, " ticket: ",otc," comm: ", mcom, " MN: ",MagicNumber," SL: ",SLLevel, " TP: ",TPLevel);
                        opordlog();
                     }
                  }
               } else { Print("Error: Order already opened!"); }

         }
      }

      t_spread=MarketInfo(ap, MODE_SPREAD);
      Order = SIGNAL_NONE;
      stp=0;
      
      if ((l1>0) && (tpo[2]==-1) && (!NoSellToday))
      {
         nop=iOpen(ap, PERIOD_H1, 0);
         nhigh=iHigh(ap, PERIOD_H1, 0);
         ncl=iClose(ap, PERIOD_H1, 0);
         oke=false;

         if ((nhigh>BrkDN) && (nop>BrkDN) && (Bid<BrkDN))
         {
            oke=true;
         }

         if (!oke)
         {
            pTLBD=ll2+(ll1-ll2)/(l2-l1)*(l2-1);
            nop=iOpen(NULL, PERIOD_H1, 0);
            pcl=iClose(NULL, PERIOD_H1, 1);
            plow=iLow(NULL, PERIOD_H1, 1);
            phg=iHigh(NULL, PERIOD_H1, 1);
            pop=iOpen(NULL, PERIOD_H1, 1);
            if ((pcl>BrkDN) && (pcl<pop) && (nop<BrkDN) && (Bid<BrkDN))
            {
               oke=true;
            }
            if ((pcl<BrkDN) && (pcl>pop) && (phg>BrkDN) && (nop<BrkDN) && (Bid<BrkDN))
            {
               oke=true;
            }
         }

         for(ni=1;ni<8;ni++)
         {
            if (MTFCheck[ni]) { if (MTFs[ni]!=2) { oke=false; ni=8; } }
         }

         //if (ChkPPMADir(ap, PERIOD_M5, 1)!=2) { oke=false; }
         //if (oke) { if (ChkPPMADir(ap, PERIOD_M5, 0)!=2) { oke=false; } }

         if ( (Bid<BrkDN) && (Bid>BrkDN-(TLBreakoutMaxPips*Point)) && oke )
         {
            if (UseSetup1)
            {
               double slp=1000; 
               int sls=0; 

               stt=iTime(ap, PERIOD_H1,0);
               for (keres=2;keres<26;keres++)
               {
                  if (iTime(ap, PERIOD_M5, keres)>stt)
                  {
                     double pl0=iLow(ap, PERIOD_M5, keres-1);
                     double pl1=iLow(ap, PERIOD_M5, keres);
                     double pl2=iLow(ap, PERIOD_M5, keres+1);
                     if ((pl1<pl0) && (pl1<pl2) && (pl1<BrkDN)) { if (pl1<slp) { slp=pl1; sls=keres; } }
                  }
                  if ((Bid<(slp-(dgt*Point))) && (sls>0))
                  {
                     Order = SIGNAL_SELL;
                     stp=1;
                  }
               }
               if (sls>0) { comm2=comm2+"SLP: "+DoubleToStr(slp,Digits)+"\n"; }
            }
            if (UseSetup2)
            {
               po0=iOpen(ap, PERIOD_M5, 0);
               pc0=iClose(ap, PERIOD_M5, 0);
               po1=iOpen(ap, PERIOD_M5, 1);
               pc1=iClose(ap, PERIOD_M5, 1);
               po2=iOpen(ap, PERIOD_M5, 2);
               pc2=iClose(ap, PERIOD_M5, 2);
               if ((pc2<BrkDN) && (pc2<po2) && (pc1<po1) && (pc1<pc2) && (pc0<po0) && (po1<BrkDN) && (po2<BrkDN))
               {
                  Order = SIGNAL_SELL;
                  stp=2;
               }
               if ((po1<BrkDN) && (pc1<BrkDN) && (po2<BrkDN) && (pc2<BrkDN) && (pc0<BrkDN) && (po0<BrkDN))
               {
                  Order = SIGNAL_SELL;
                  stp=2;
               }
            }

            if (UseSetup3)
            {
               // SETUP 3: Price below TL
               if ((Bid<BrkDN-(TLBreakoutMinPips*Point)) && (Bid>BrkDN-(TLBreakoutMaxPips*Point)))
               {
                  Order = SIGNAL_SELL;
                  stp=3;
               }
            }

            if (TradeOnlyPivotDir)
            {
               // sell only when price is below PP
               if (Bid>PPs[7][1]) { Order=SIGNAL_NONE; stp=0; }
            }

            if (Order>0)
            {
               if ((stp==1) || (stp==2) || (stp==3))
               {
                  Print("SELL ",stp," SIG ", ap, " TLBD: ", DoubleToStr(BrkDN,Digits), " slp: ", DoubleToStr(slp,Digits), " SL: ", DoubleToStr(sellsl,Digits) ," TP: ", DoubleToStr(selltgt,Digits));
               }
            }
         }
      }

      t_spread=MarketInfo(ap, MODE_SPREAD);

      if (Order==SIGNAL_SELL)
      {
         if ((t_spread>maxspread) && (!fixedspread))
         {
            Print("SPREAD TOO HIGH: ", ap, "/",tfc,": spread: ", DoubleToStr(t_spread,0));
            NoNewTrade=true;
            Order=0;
         }

         elog=comm2+"\n";
         elog=elog+TLcomm[5]+TLcomm[6]+TLcomm[7]+TLcomm[8];
         elog=elog+"---------------------\n"+comm1;

         if (TradeType1) 
         {
            MagicNumber=makemagicnr(apnr, 1);
            if (!checkopenorder(ap, 2, MagicNumber))
            {
               mcom="SELL T1("+stp+") "+DoubleToStr(MagicNumber,0);
               SLLevel=NormalizeDouble(sellsl,Digits);
               TPLevel=NormalizeDouble(selltgt,Digits);
               otc=OpenOrder(OP_SELL, mcom, MagicNumber, SLLevel, TPLevel, 0);
               if (otc>0)
               {
                  Print ("open SELL 1 ", ap, " ticket: ",otc, " comm: ", mcom, " MN: ",MagicNumber," SL: ",SLLevel, " TP: ",TPLevel);
                  opordlog();
               }
            } else { Print("Error: Order already opened!"); }
         }
         if (TradeType2)
         {
            MagicNumber=makemagicnr(apnr, 2);
            if (!checkopenorder(ap, 2, MagicNumber))
            {
               mcom="SELL T2("+stp+") "+DoubleToStr(MagicNumber,0);
               SLLevel=NormalizeDouble(sellsl,Digits);
               TPLevel=NormalizeDouble(0,Digits);
               otc=OpenOrder(OP_SELL, mcom, MagicNumber, SLLevel, TPLevel, 0);
               if (otc>0)
               {
                  Print ("open SELL 2 ", ap, " ticket: ",otc, " comm: ", mcom, " MN: ",MagicNumber," SL: ",SLLevel, " TP: ",TPLevel);
                  opordlog();
               }
            } else { Print("Error: Order already opened!"); }
         }
         if (TradeType3)
         {
            MagicNumber=makemagicnr(apnr, 3);
            if (!checkopenorder(ap, 2, MagicNumber))
            {
               mcom="SELL T3("+stp+") "+DoubleToStr(MagicNumber,0);
               SLLevel=NormalizeDouble(sellsl,Digits);
               TPLevel=NormalizeDouble(0,Digits);
               otc=OpenOrder(OP_SELL, mcom, MagicNumber, SLLevel, TPLevel, 0);
               if (otc>0)
               {
                  Print ("open SELL 3 ", ap, " ticket: ",otc, " comm: ", mcom, " MN: ",MagicNumber," SL: ",SLLevel, " TP: ",TPLevel);
                  opordlog();
               }
            } else { Print("Error: Order already opened!"); }
         }
      }

      // --- SELL ---------------------------------------------------------------------------------
      // ------------------------------------------------------------------------------------------

   }

   //comm2=comm2+"---------------------\n";
   comm2=comm2+"\n"+""+"\n";
   //comm2=comm2+TLcomm[5]+TLcomm[6]+TLcomm[7]+TLcomm[8];
   string comm=comm2+"---------------------\n"+comm1;
   Comment(comm);

   initlog--;
   if (initlog==0)
   {
      elog=comm2+"---------------------\n";
      elog=elog+"\n";
      elog=elog+TLcomm[5]+TLcomm[6]+TLcomm[7]+TLcomm[8];
      elog=elog+"---------------------\n"+comm1;
      opordlog();
   }

      //+------------------------------------------------------------------+
      //| Signal Begin(Entry)                                              |
      //+------------------------------------------------------------------+


      //+------------------------------------------------------------------+
      //| Signal End                                                       |
      //+------------------------------------------------------------------+

   return(0);
}

//+------------------------------------------------------------------+

void Draw_H1_Trends(int sh, int sl)
{
   int sbar=0;
   int ebar=0;

   string ap=Symbol();   
   ArrayCopyRates(rate_array, ap, PERIOD_H1);

   H1R_E=0; H1R_S=0; H1S_E=0; H1S_S=0;

   if (sh>0)
   {
      ebar=sh;
      if ((H1R_E==0) && (H1R_S==0))
      {
         double pp1=iHigh(ap, PERIOD_H1, ebar);
         sbar=FindNextSwing(ap, PERIOD_H1, pp1+Point, 2, ebar);
         if (sbar>ebar)
         { 
            H1R_E=ebar;  H1R_S=sbar;
            DrawTrendline ("H1_R_", ebar, sbar, PERIOD_H1, RESISTANCE, rate_array);
         }
      }
      //Print (ap, " TL H1_R E: ",H1R_E," S: ",H1R_E);
      //Print (ap, " TL H1_R 1: ", ",", ebar, ",", sbar);
      if (sbar<0) { sbar=0; }
      if ((ebar>0) && (sbar==0))
      {
         Print(ap," NO 2nd SWING HIGH IN H1 History");
         comm_tech_tls="NO 2nd SWING HIGH IN H1 History\n";
         // van egy els sh de nincs hozz 2.
         // findnextswing helyett high>open & high>close
         int h1bars=iBars(ap, PERIOD_H1);
         double ph1 = iHigh(ap, PERIOD_H1, ebar);
         datetime dh1 = iTime(ap, PERIOD_H1, h1bars);
         int s2=0, sbar2=0;
         for (int ii=5;ii<10;ii++)
         {
            sbar2=FindNextSwing(ap, TFs[ii], ph1+Point, 2, ebar);
            if (sbar2>0)
            {
               double ph2=iHigh(ap, TFs[ii], sbar2);
               Print(ap, " upper TL 2nd Swing High found on ",TFns[ii]," chart @ ", sbar2, " Price: ",DoubleToStr(ph2,Digits)," -> H1 shift: ", sbar2*(TFs[ii]/60), " in H1 chart only ",h1bars," bars are loaded.");
               comm_tech_tls=comm_tech_tls+" upper TL 2nd Swing High found on "+TFns[ii]+" chart @ "+sbar2+" Price: "+DoubleToStr(ph2,Digits)+" -> H1 shift: "+sbar2*(TFs[ii]/60)+" in H1 chart only "+h1bars+" bars are loaded.\n";
               s2=sbar2*(TFs[ii]/60);
               ii=11;
            }
         }
         if (s2==0)
         {
            Print(ap, " NO upper TL 2nd Swing High found on H1 or higher charts.");
            comm_tech_tls=comm_tech_tls+" NO upper TL 2nd Swing High found on H1 or higher charts.\n";
         }
      }
   }

   ebar = 0;
   sbar = 0;

   if (sl>0)
   {
      ebar=sl;
      if ((H1S_E==0) && (H1S_S==0))
      {
         pp1=iLow(ap, PERIOD_H1, ebar);
         sbar=FindNextSwing(ap, PERIOD_H1, pp1-Point, 1, ebar);
         if (sbar>ebar)
         { 
            H1S_E=ebar;  H1S_S=sbar;
            DrawTrendline ("H1_S_", ebar, sbar, PERIOD_H1, SUPPORT, rate_array);
         }
      }
      //Print (ap, " TL H1_S E: ",H1S_E," S: ",H1S_E);
      //Print (ap, " TL H1_S 1: ", ",", ebar, ",", sbar);
      if (sbar<0) { sbar=0; }
      if ((ebar>0) && (sbar==0))
      {
         Print(ap, " NO 2nd SWING LOW IN H1 History");
         comm_tech_tls=comm_tech_tls+"NO 2nd SWING LOW IN H1 History\n";
         h1bars=iBars(ap, PERIOD_H1);
         ph1 = iLow(ap, PERIOD_H1, ebar);
         dh1 = iTime(ap, PERIOD_H1, h1bars);
         s2=0; sbar2=0;
         for (ii=5;ii<10;ii++)
         {
            sbar2=FindNextSwing(ap, TFs[ii], ph1-Point, 1, ebar);
            if (sbar2>0)
            {
               pp1=iLow(ap, TFs[ii], sbar2);
               Print(ap, " lower TL 2nd Swing Low found on ",TFns[ii]," chart @ ", sbar2, " Price: ",DoubleToStr(pp1,Digits)," -> H1 shift: ", sbar2*(TFs[ii]/60), " in H1 chart only ",h1bars," bars are loaded.");
               comm_tech_tls=comm_tech_tls+" lower TL 2nd Swing Low found on "+TFns[ii]+" chart @ "+sbar2+" Price: "+DoubleToStr(pp1,Digits)+" -> H1 shift: "+sbar2*(TFs[ii]/60)+" in H1 chart only "+h1bars+" bars are loaded.\n";
               s2=sbar2*(TFs[ii]/60);
               ii=11;
            }
         }
         if (s2==0)
         {
            Print(ap, " NO lower TL 2nd Swing Low found on H1 or higher charts.");
            comm_tech_tls=comm_tech_tls+" NO lower TL 2nd Swing Low found on H1 or higher charts.\n";
         }
      }
   }

}

//+------------------------------------------------------------------+

double array[][6];

//+------------------------------------------------------------------+

int GetRealPosition(int p1, double array[][6], int which, datetime value, double peak)
{
   int i;
 
   for (i=0; i < Bars; i++)
   {
     if (array[i][0] == value || array[i][0] < value)
     {
        if (which == RESISTANCE)
        {
          if (array[i][3] == peak) return (i);
          if (array[i-1][3] == peak) return (i-1);
          if (array[i-2][3] == peak) return (i-2);
          if (array[i-3][3] == peak) return (i-3);
         } else {
          if (array[i][2] == peak) return (i);
          if (array[i-1][2] == peak) return (i-1);
          if (array[i-2][2] == peak) return (i-2);
          if (array[i-3][2] == peak) return (i-3);
         } 
         if (array[i][0] < value) return (i);
     }
   }
   return (-1);
}
 
int DrawTrendline (string name, int p1, int p2, int timeframe, int which, double r_array[][6])
 {
   color hue;
   int thickness = 1;
   int style = STYLE_DASH;
  
   ArrayCopyRates(array, Symbol(), Period());
    
   if (which == RESISTANCE) 
   {
     hue = RoyalBlue;
     if (Period() != timeframe)
     {
       p1 = GetRealPosition(p1, array, which, r_array[p1][0], r_array[p1][3]);
       p2 = GetRealPosition(p2, array, which, r_array[p2][0], r_array[p2][3]);
     }
   }
   else
   {
     hue = FireBrick;
     if (Period() != timeframe)
     {
       p1 = GetRealPosition(p1, array, which, r_array[p1][0], r_array[p1][2]);
       p2 = GetRealPosition(p2, array, which, r_array[p2][0], r_array[p2][2]);
     }
   }
      
   switch(timeframe)
   {
      case PERIOD_H1:
         style = STYLE_SOLID;
         thickness = 2;
         if ((name=="H1_R") || (name=="H1_S")) { style = STYLE_DOT; thickness = 1; }
         //Print("TLD ",Symbol(), "/",timeframe,"/ name: |", name,"| style: ", style, " thickness: ", thickness); 
         if (which == RESISTANCE)
            if (name=="H1_R") { hue = H1_R; }
            if (name=="H1_R_") { hue = H1_R_; }
         else
            if (name=="H1_S") { hue = H1_S; }
            if (name=="H1_S_") { hue = H1_S_; }
         break;
      case PERIOD_H4:
         style = STYLE_DOT;
         thickness = 1;
         if (which == RESISTANCE)
           hue = H4_R;
         else
           hue = H4_S;
         break;
      case PERIOD_D1:
         style = STYLE_DOT;
         thickness = 1;
         if (which == RESISTANCE)
           hue = D1_R;
         else
           hue = D1_S;
         break;
      case PERIOD_W1:
         style = STYLE_DOT;
         thickness = 1;
         if (which == RESISTANCE)
           hue = W1_R;
         else
           hue = W1_S;
         break;
      default:
         style = STYLE_DASHDOTDOT;
         thickness = 1;
         if (which == RESISTANCE)
           hue = H1_R;
         else
           hue = H1_S;
         break;
   }

   ObjectDelete(name);   
   if (ObjectFind(name) < 0)
   {
     if (which == SUPPORT)
       ObjectCreate(name, OBJ_TREND, 0, array[p2][0], array[p2][2], array[p1][0], array[p1][2]);
     else
       ObjectCreate(name, OBJ_TREND, 0, array[p2][2], array[p2][3], array[p1][0], array[p1][3]);
   }    
   ObjectSet(name, OBJPROP_COLOR, hue);
   ObjectSet(name, OBJPROP_RAY, true);
   ObjectSet(name, OBJPROP_BACK, true);
   ObjectSet(name, OBJPROP_WIDTH, thickness);
   ObjectSet(name, OBJPROP_STYLE, style);

   if (which == SUPPORT)
   { // Lows (0 == Time)
     if (array[p2][0]>0) { ObjectMove (name, 0, array[p2][0], array[p2][2]); }
     if (array[p1][0]>0) { ObjectMove (name, 1, array[p1][0], array[p1][2]); }
   }
   else
   { // Highs
     if (array[p2][0]>0) { ObjectMove (name, 0, array[p2][0], array[p2][3]); }
     if (array[p1][0]>0) { ObjectMove (name, 1, array[p1][0], array[p1][3]); }
   }

   WindowRedraw();
   return(0);
}

//+------------------------------------------------------------------+

void Calc_SR6(string ap, int tfc, int tfnr)
{
   int Contract_Step=150;
   int Precision=10;
   int Shift_Bars=1;

   ArrayInitialize(v1,0);
   ArrayInitialize(v2,0);

   double gap;
   double contract = (Contract_Step + Precision) * Point;
   int i = 100;
   int shift; 
   bool fractal;
   double price;
   while(i>=0)
   {
      shift = i + Shift_Bars;
      // Resistance
      price = iHigh(ap,tfc,shift+2);
      fractal = price >= iHigh(ap,tfc,shift+4) &&
              price >= iHigh(ap,tfc,shift+3) &&
              price > iHigh(ap,tfc,shift+1) &&
              price > iHigh(ap,tfc,shift);
              
      gap = v1[i+1] - price;
      if (fractal && (gap >= contract || gap < 0))
      {
         v1[i] = price + (Precision * Point);
      } else {
         v1[i] = v1[i+1];
      }

      // Support
      price = iLow(ap,tfc,shift+2);
      fractal = price <= iLow(ap,tfc,shift+4) &&
                price <= iLow(ap,tfc,shift+3) &&
                price < iLow(ap,tfc,shift+1) &&
                price < iLow(ap,tfc,shift);
              
      gap = price - v2[i+1];
      if (fractal && (gap >= contract || gap < 0))
      {
         v2[i] = price - (Precision * Point);
      } else {
         v2[i] = v2[i+1];
      }
      i--;
   }
   SR6S[tfnr]=v2[0];
   SR6R[tfnr]=v1[0];
}

//+------------------------------------------------------------------+
//| return error description                                         |
//+------------------------------------------------------------------+
string ErrorDescription(int error_code)
  {
   string error_string;
//----
   switch(error_code)
     {
      //---- codes returned from trade server
      case 0:
      case 1:   error_string="no error";                                                  break;
      case 2:   error_string="common error";                                              break;
      case 3:   error_string="invalid trade parameters";                                  break;
      case 4:   error_string="trade server is busy";                                      break;
      case 5:   error_string="old version of the client terminal";                        break;
      case 6:   error_string="no connection with trade server";                           break;
      case 7:   error_string="not enough rights";                                         break;
      case 8:   error_string="too frequent requests";                                     break;
      case 9:   error_string="malfunctional trade operation";                             break;
      case 64:  error_string="account disabled";                                          break;
      case 65:  error_string="invalid account";                                           break;
      case 128: error_string="trade timeout";                                             break;
      case 129: error_string="invalid price";                                             break;
      case 130: error_string="invalid stops";                                             break;
      case 131: error_string="invalid trade volume";                                      break;
      case 132: error_string="market is closed";                                          break;
      case 133: error_string="trade is disabled";                                         break;
      case 134: error_string="not enough money";                                          break;
      case 135: error_string="price changed";                                             break;
      case 136: error_string="off quotes";                                                break;
      case 137: error_string="broker is busy";                                            break;
      case 138: error_string="requote";                                                   break;
      case 139: error_string="order is locked";                                           break;
      case 140: error_string="long positions only allowed";                               break;
      case 141: error_string="too many requests";                                         break;
      case 145: error_string="modification denied because order too close to market";     break;
      case 146: error_string="trade context is busy";                                     break;
      //---- mql4 errors
      case 4000: error_string="no error";                                                 break;
      case 4001: error_string="wrong function pointer";                                   break;
      case 4002: error_string="array index is out of range";                              break;
      case 4003: error_string="no memory for function call stack";                        break;
      case 4004: error_string="recursive stack overflow";                                 break;
      case 4005: error_string="not enough stack for parameter";                           break;
      case 4006: error_string="no memory for parameter string";                           break;
      case 4007: error_string="no memory for temp string";                                break;
      case 4008: error_string="not initialized string";                                   break;
      case 4009: error_string="not initialized string in array";                          break;
      case 4010: error_string="no memory for array\' string";                             break;
      case 4011: error_string="too long string";                                          break;
      case 4012: error_string="remainder from zero divide";                               break;
      case 4013: error_string="zero divide";                                              break;
      case 4014: error_string="unknown command";                                          break;
      case 4015: error_string="wrong jump (never generated error)";                       break;
      case 4016: error_string="not initialized array";                                    break;
      case 4017: error_string="dll calls are not allowed";                                break;
      case 4018: error_string="cannot load library";                                      break;
      case 4019: error_string="cannot call function";                                     break;
      case 4020: error_string="expert function calls are not allowed";                    break;
      case 4021: error_string="not enough memory for temp string returned from function"; break;
      case 4022: error_string="system is busy (never generated error)";                   break;
      case 4050: error_string="invalid function parameters count";                        break;
      case 4051: error_string="invalid function parameter value";                         break;
      case 4052: error_string="string function internal error";                           break;
      case 4053: error_string="some array error";                                         break;
      case 4054: error_string="incorrect series array using";                             break;
      case 4055: error_string="custom indicator error";                                   break;
      case 4056: error_string="arrays are incompatible";                                  break;
      case 4057: error_string="global variables processing error";                        break;
      case 4058: error_string="global variable not found";                                break;
      case 4059: error_string="function is not allowed in testing mode";                  break;
      case 4060: error_string="function is not confirmed";                                break;
      case 4061: error_string="send mail error";                                          break;
      case 4062: error_string="string parameter expected";                                break;
      case 4063: error_string="integer parameter expected";                               break;
      case 4064: error_string="double parameter expected";                                break;
      case 4065: error_string="array as parameter expected";                              break;
      case 4066: error_string="requested history data in update state";                   break;
      case 4099: error_string="end of file";                                              break;
      case 4100: error_string="some file error";                                          break;
      case 4101: error_string="wrong file name";                                          break;
      case 4102: error_string="too many opened files";                                    break;
      case 4103: error_string="cannot open file";                                         break;
      case 4104: error_string="incompatible access to a file";                            break;
      case 4105: error_string="no order selected";                                        break;
      case 4106: error_string="unknown symbol";                                           break;
      case 4107: error_string="invalid price parameter for trade function";               break;
      case 4108: error_string="invalid ticket";                                           break;
      case 4109: error_string="trade is not allowed";                                     break;
      case 4110: error_string="longs are not allowed";                                    break;
      case 4111: error_string="shorts are not allowed";                                   break;
      case 4200: error_string="object is already exist";                                  break;
      case 4201: error_string="unknown object property";                                  break;
      case 4202: error_string="object is not exist";                                      break;
      case 4203: error_string="unknown object type";                                      break;
      case 4204: error_string="no object name";                                           break;
      case 4205: error_string="object coordinates error";                                 break;
      case 4206: error_string="no specified subwindow";                                   break;
      default:   error_string="unknown error";
     }
//----
   return(error_string);
  }  
//+------------------------------------------------------------------+

void objdel()
{
   for (int tt=1;tt<14;tt++)
   {
      for (int tt2=1;tt2<4;tt2++)
      {
         ObjectDelete(PPTFn[tt2]+PPn[tt]+" Label");
         ObjectDelete(PPTFn[tt2]+PPn[tt]+" Line");
      }
   }

   ObjectDelete("IB-box-H1");
   ObjectDelete("IB-lineH-H1");
   ObjectDelete("IB-lineL-H1");
   ObjectDelete("IB-box-H4");
   ObjectDelete("IB-lineH-H4");
   ObjectDelete("IB-lineL-H4");
   ObjectDelete("IB-box-D1");
   ObjectDelete("IB-lineH-D1");
   ObjectDelete("IB-lineL-D1");
   ObjectDelete("IB-box-W1");
   ObjectDelete("IB-lineH-W1");
   ObjectDelete("IB-lineL-W1");

   ObjectDelete("SW-box-H1");
   ObjectDelete("SW-lineH-H1");
   ObjectDelete("SW-lineL-H1");
   ObjectDelete("SW-box-H4");
   ObjectDelete("SW-lineH-H4");
   ObjectDelete("SW-lineL-H4");
   ObjectDelete("SW-box-D1");
   ObjectDelete("SW-lineH-D1");
   ObjectDelete("SW-lineL-D1");
   ObjectDelete("SW-box-W1");
   ObjectDelete("SW-lineH-W1");
   ObjectDelete("SW-lineL-W1");

   ObjectDelete("WR-Start-2");
   ObjectDelete("WR-Start");
   ObjectDelete("WR-End");

   ObjectDelete("H1_S_");
   ObjectDelete("H1_R_");

   ObjectDelete("H1_S");
   ObjectDelete("H1_R");
   ObjectDelete("H4_S");
   ObjectDelete("H4_R");
   ObjectDelete("D1_S");
   ObjectDelete("D1_R");
   ObjectDelete("W1_S");
   ObjectDelete("W1_R");
   return(0);
}